unit ROIFrmu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Trackcur, Horzbaru, ComCtrls, MPViewu, MPFileu, ExtCtrls, Vieweru;

type
  TROIFrm = class(TForm)
    MainMenu1: TMainMenu;
    Axis1: TMenuItem;
    XAxis1: TMenuItem;
    YAxis1: TMenuItem;
    Data1: TMenuItem;
    Copydatatoclipboard1: TMenuItem;
    StatusBar1: TStatusBar;
    N1: TMenuItem;
    ResetCursorRelativeOrigins1: TMenuItem;
    PopupMenu1: TPopupMenu;
    ResetRelative1: TMenuItem;
    N2: TMenuItem;
    XAxisFullRange1: TMenuItem;
    YAxisFullRange1: TMenuItem;
    PreviousMagnification1: TMenuItem;
    YAxisAutoscale1: TMenuItem;
    CopydatatoclipboardasTEXT1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure XAxis1Click(Sender: TObject);
    procedure YAxis1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ResetCursorRelativeOrigins1Click(Sender: TObject);
    procedure HorzTrackBar1Change(Sender: TObject);
    procedure Copydatatoclipboard1Click(Sender: TObject);
    procedure XAxisFullRange1Click(Sender: TObject);
    procedure YAxisFullRange1Click(Sender: TObject);
    procedure YAxisAutoscale1Click(Sender: TObject);
    procedure PreviousMagnification1Click(Sender: TObject);
    procedure VertTrackBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure CopydatatoclipboardasTEXT1Click(Sender: TObject);
  private
    { Private declarations }
    bInitialized, {prevents FormPaint before first FormResize}
    bAdjustingCursorPos: boolean; {prevent activation of OnChange events}
    fDataSize: integer;
 
    prev_xLeft, prev_xWidth,
    prev_yTop, prev_yHeight: integer;

    {rectangle areas}
    bitmapWidth, bitmapHeight: integer;
    viewRect,
    xAxisRect,
    yAxisRect,
    cornerRect: TRect;

    xCursorPos,
    yCursorPos,
    refXCursorPos,
    refYCursorPos: integer;

    HorzTrackBar1: THorzTrackBar;
    VertTrackBar1: TVertTrackBar;

    procedure AdjustCursorPos;
    procedure AdjustLogicalCursorPos;
    procedure DrawBitmap;
    procedure DrawData;
    procedure DrawXCursorOnBitmap;
    procedure DrawXCursorOnScreen;
    procedure DrawAxis;
    procedure DrawYCursorOnBitmap;
    procedure DrawYCursorOnScreen;
    procedure OnMagnificationChanged;
    function  RectBitmapToWindow(aRect: TRect): TRect;
    function  RectWindowToBitmap(aRect: TRect): TRect;
    procedure RedrawOffScreen;
    procedure ResizeElements;
    procedure SetDataSize(newSize: integer);
    procedure SetPrecision(newPrecision: TPrecision);
    procedure UpdateCursorCaptions;
    function  XBitmapToData(xBitmap: integer): integer;
    function  XCursorDataToBitmap(xData: integer): integer;
    function  YBitmapToData(yBitmap: integer): integer;
    function  YDataToBitmap(yData: integer): integer;
  public
    { Public declarations }
    bLineProfile: boolean;
    f_MAX_Y_VALUE: integer;
    bDontUnregister: boolean;
    {axis}
    frameRate: double; {in seconds}
    fromFrame, toFrame,
    xLeft, xWidth,
    yTop, yHeight: integer; {logical values}
    cXTickMarks, cYTickMarks: integer;

    dataBuffer: array of integer;
    trace: TTrace;

    offscreenBitmap: TBitmap;

   procedure SavePrevMag;
	procedure SaveDataToFile(bASCII: boolean; padding: integer; filename: string);
    property dataSize: integer read fDataSize write SetDataSize;
    property precision: TPrecision write SetPrecision;
  end;

var
  ROIFrm: TROIFrm;

implementation

{$R *.DFM}

uses ROIAxisDlgu, Clipbrd;

const
   TRACK_BAR_WIDTH = 17;
   TRACK_BAR_HEIGHT = 17;
   Y_AXIS_WIDTH = 75;
   X_AXIS_HEIGHT = 35;

{**************************** PRIVATE METHODS *********************************}

procedure TROIFrm.AdjustCursorPos;
begin
   bAdjustingCursorPos := True;
   VertTrackBar1.Position := {bitmapHeight - 1 -} Muldiv(yCursorPos - (yTop - yHeight + 1),
       bitmapHeight - 1, yHeight - 1);
   HorzTrackBar1.Position := Muldiv(xCursorPos - (xLeft + xWidth - 1), bitmapWidth - 1, - xWidth + 1);
   bAdjustingCursorPos := False;
end;


procedure TROIFrm.AdjustLogicalCursorPos;
begin
   xCursorPos := XBitmapToData(HorzTrackBar1.Position);
   yCursorPos := YBitmapToData(bitmapHeight - 1 - VertTrackBar1.Position);
end;


procedure TROIFrm.DrawBitmap;
begin
   with offscreenBitmap.Canvas do
   begin
       Brush.Color := clBlack;
       FillRect(Rect(0, 0, bitmapWidth - 1, bitmapHeight - 1));
   end;
end;


procedure TROIFrm.DrawData;
var    lastIndex, firstIndex, i, j, k, indexofnextpt,
       dataVal, maxVal, minVal: integer;
       bitmapY, bitmaprY: integer;
begin
   lastIndex := -1; firstIndex := -1;

   for i := 0 to bitmapWidth - 1 do {index in trace}
   begin
       j := XBitmapToData(i); {index in data buffer}
       indexofnextpt := XBitmapToData(i + 1) - 1;

       if (j >= 0) and (j < datasize) then
       begin
           if firstIndex = -1 then firstIndex := i;
           lastIndex := i;
           trace[i].MaxPt.y := dataBuffer[j];
           trace[i].MinPt.y := trace[i].MaxPt.y;

           if (indexofnextPt > j) and (indexofnextPt < datasize) and
           (j < datasize - 1) then
           for k := j + 1 to indexofnextPt do
               begin
                   dataVal := dataBuffer[k];
                   if dataVal > trace[i].MaxPt.y then trace[i].MaxPt.y := dataVal;
                   if dataVal < trace[i].MinPt.y then trace[i].MinPt.y := dataVal;
               end;

       end; {j}
   end; {i}

   if (lastIndex <> -1) and (firstIndex <> -1) and (firstIndex < lastIndex) then
   begin
       if YAxisAutoscale1.Checked then
       begin
           {Autoscale}
           maxVal := trace[firstIndex].MaxPt.y;
           minVal := trace[firstIndex].MinPt.y;

           {find the maximum and minimum values}
           for i := firstIndex + 1 to lastIndex do
           begin
               if maxVal < trace[i].MaxPt.y then maxVal := trace[i].MaxPt.y;
               if minVal < trace[i].MinPt.y then minVal := trace[i].MinPt.y;
           end;

           {at least 100 pixel difference for autoscale}
           if maxVal >= minVal + 100 then
           begin
               bitmapY := YDataToBitmap(YCursorPos);
               bitmaprY := YDataToBitmap(refYCursorPos);

               yTop := (maxVal + minVal) div 2 + Muldiv(10, (maxVal - minVal + 1) div 2, 9);
               yHeight := Muldiv(10, maxVal - minVal + 1, 9);
               if yTop > f_MAX_Y_VALUE then yTop := f_MAX_Y_VALUE;
               if yTop - yHeight < - f_MAX_Y_VALUE - 1 then
                   yHeight := f_MAX_Y_VALUE + 1 + yTop;

               DrawAxis;
               YCursorPos := YBitmapToData(bitmapY);
               refYCursorPos := YBitmapToData(bitmaprY);
               UpdateCursorCaptions;
           end;
       end;

       {logical to bitmap Y}
       for i := firstIndex to lastIndex do
       begin
           dataVal := YDataToBitmap(trace[i].MaxPt.y);
           if dataVal < 0 then dataVal := 0; if dataVal >= bitmapHeight then dataVal := bitmapHeight - 1;
           trace[i].MaxPt.y := dataVal;

           dataVal := YDataToBitmap(trace[i].MinPt.y);
           if dataVal < 0 then dataVal := 0; if dataVal >= bitmapHeight then dataVal := bitmapHeight - 1;
           trace[i].MinPt.y := dataVal;
       end;

       with offscreenbitmap.Canvas do
       begin
           Pen.Color := clWhite;
           Pen.Mode := pmCopy;
           Pen.Style := psSolid;
           Pen.Width := 1;
       end;

       Windows.Polyline(offscreenBitmap.Canvas.Handle, trace[firstIndex].MaxPt,
           2 * (lastIndex - firstIndex + 1));
   end;
end;


procedure TROIFrm.DrawAxis;
var    i, x: integer;
      { timebase: double;} {in s}
       y, tw, th: integer;
       s: string;
begin
   Canvas.Brush.Color := clBtnFace;
   Canvas.FillRect(xAxisRect);
   Canvas.FillRect(yAxisRect);

   with Canvas.Pen do
   begin
       Color := clBlue;
       Width := 1;
       Style := psSolid;
       Mode := pmCopy;
   end;

   for i := 0 to cXTickMarks - 1 do
   begin
       x := viewRect.Left + MulDiv(i, bitmapWidth - 1, cXTickMarks - 1);
       if i > 1 then x := x - 1; {adjusting for pen width}
       Canvas.MoveTo(x, xAxisRect.Top);
       Canvas.LineTo(x, xAxisRect.Top + 10);
   end;


  if not bLineProfile then
  { timebase := xWidth / (cXTickMarks - 1) / Mainform.configuration.frameRate;}
   s := Format('%.2f', [xWidth / (cXTickMarks - 1)]) + ' frames / division'
       { + Format('%.2f', [timebase]) + ' s' }
   else
   	s := 'Pixels';

   Canvas.Textout(xAxisRect.Left + (xAxisRect.Right - xAxisRect.Left) div 2
       - Canvas.TextWidth(s) div 2, xAxisRect.Bottom - 20, s);

   for i := 0 to cYTickMarks - 1 do
   begin
       y := viewRect.Top + MulDiv(i, bitmapHeight - 1, cYTickMarks - 1);
       Canvas.MoveTo(yAxisRect.Right - 10, y);
       Canvas.LineTo(yAxisRect.Right, y);
       s := IntToStr(yTop - Muldiv(i, yHeight - 1, cYTickMarks - 1));
       tw := Canvas.TextWidth(s);
       th := Canvas.TextHeight(s);
       Canvas.TextOut(yAxisRect.Right - tw - 15, y - th div 2, s);
   end;
end;


procedure TROIFrm.DrawXCursorOnBitmap;
var    bitmapXCursor: integer;
begin
   bitmapXCursor := XCursorDataToBitmap(xCursorPos);
   with offscreenbitmap.Canvas do
   begin
       Pen.Color := clYellow;
       Pen.Mode := pmXor;
       Pen.Style := psDot;
       Pen.Width := 1;
       MoveTo(bitmapXCursor, 0);
       LineTo(bitmapXCursor, bitmapHeight - 1);
   end;
end;


procedure TROIFrm.DrawXCursorOnScreen;
var    bitmapXCursor: integer;
       rc: TRect;
begin
   bitmapXCursor := XCursorDataToBitmap(xCursorPos);
   rc := Rect(bitmapXCursor - 1, 0, bitmapXCursor + 1, bitmapHeight - 1);
   Canvas.CopyRect(RectBitmapToWindow(rc), offscreenBitmap.Canvas, rc);
end;


procedure TROIFrm.DrawYCursorOnBitmap;
var    bitmapYCursor: integer;
begin
   bitmapYCursor := YDataToBitmap(yCursorPos);
   with offscreenbitmap.Canvas do
   begin
       Pen.Color := clYellow;
       Pen.Mode := pmXor;
       Pen.Style := psDot;
       Pen.Width := 1;
       MoveTo(0, bitmapYCursor);
       LineTo(bitmapWidth - 1, bitmapYCursor);
   end;
end;


procedure TROIFrm.DrawYCursorOnScreen;
var    bitmapYCursor: integer;
       rc: TRect;
begin
   bitmapYCursor := YDataToBitmap(yCursorPos);
   rc := Rect(0, bitmapYCursor - 1,  bitmapWidth - 1, bitmapYCursor + 1);
   Canvas.CopyRect(RectBitmapToWindow(rc), offscreenBitmap.Canvas, rc);
end;


procedure TROIFrm.OnMagnificationChanged;
begin
   RedrawOffScreen;
   AdjustLogicalCursorPos;
   Invalidate;
   UpdateCursorCaptions;
end;


function  TROIFrm.RectBitmapToWindow(aRect: TRect): TRect;
begin
   OffsetRect(aRect, viewRect.Left, viewRect.Top);
   Result := aRect;
end;


function  TROIFrm.RectWindowToBitmap(aRect: TRect): TRect;
begin
   OffsetRect(aRect, -viewRect.Left, -viewRect.Top);
   Result := aRect;
end;


procedure TROIFrm.RedrawOffScreen;
begin
   DrawBitmap;
   DrawData;
   DrawXCursorOnBitmap;
   DrawYCursorOnBitmap;
end;


procedure TROIFrm.ResizeElements;
var    i: integer;
begin
   {rectangles}
   cornerRect := Rect(ClientWidth - TRACK_BAR_WIDTH, 0, ClientWidth - 1, TRACK_BAR_HEIGHT - 1);
   yAxisRect := Rect(0, 0, Y_AXIS_WIDTH - 1, ClientHeight - StatusBar1.Height - 1);
   xAxisRect := Rect(Y_AXIS_WIDTH, ClientHeight - StatusBar1.Height - X_AXIS_HEIGHT - 1, ClientWidth,
       ClientHeight - StatusBar1.Height - 1);
   viewRect := Rect(Y_AXIS_WIDTH + 1, TRACK_BAR_HEIGHT + 1, ClientWidth - TRACK_BAR_WIDTH,
       ClientHeight - X_AXIS_HEIGHT - StatusBar1.Height);

   bitmapWidth := viewRect.Right - viewRect.Left + 1;
   bitmapHeight := viewRect.Bottom - viewRect.Top + 1;

   offscreenBitmap.Width := bitmapWidth;
   offscreenBitmap.Height := bitmapHeight;

   SetLength(trace, bitmapWidth);
   for i := 0 to bitmapWidth - 1 do
   begin
       trace[i].MaxPt.x := i;
       trace[i].MinPt.x := i;
   end;

   HorzTrackBar1.Min := 0;
   HorzTrackBar1.Max := bitmapWidth - 1;
   VertTrackBar1.Min := 0;
   VertTrackBar1.Max := bitmapHeight - 1;

   HorzTrackBar1.SetBounds(Y_AXIS_WIDTH, 0, ClientWidth - TRACK_BAR_WIDTH - Y_AXIS_WIDTH, TRACK_BAR_HEIGHT);
   VertTrackBar1.SetBounds(ClientWidth - TRACK_BAR_WIDTH, TRACK_BAR_HEIGHT,
       TRACK_BAR_WIDTH, ClientHeight - TRACK_BAR_HEIGHT - StatusBar1.Height - X_AXIS_HEIGHT);

   UpdateCursorCaptions;

   RedrawOffscreen;
end;


procedure TROIFrm.SetDataSize(newSize: integer);
begin
   fDataSize := newSize;
   SetLength(dataBuffer, fDataSize);
   xLeft := 0;
   xWidth := newSize;
end;


procedure TROIFrm.SetPrecision(newPrecision: TPrecision);
begin
   case newPrecision of
       PREC_8_BIT: f_MAX_Y_VALUE := 127;
       PREC_10_BIT: f_MAX_Y_VALUE := 511;
       PREC_12_BIT: f_MAX_Y_VALUE := 2047;
       PREC_14_BIT: f_MAX_Y_VALUE := 8191;
       else f_MAX_Y_VALUE := 32767;
   end;
end;


procedure TROIFrm.UpdateCursorCaptions;
begin
   StatusBar1.Panels[0].Text := 'X: ' + IntToStr(xCursorPos);
   StatusBar1.Panels[1].Text := 'Y: ' + IntToStr(yCursorPos);
   StatusBar1.Panels[2].Text := 'rX: ' + IntToStr(xCursorPos - refXCursorPos);
   StatusBar1.Panels[3].Text := 'rY: ' + IntToStr(YCursorPos - refYCursorPos);
end;


function  TROIFrm.XBitmapToData(xBitmap: integer): integer;
begin
   Result := MulDiv(xBitmap, xWidth - 1, bitmapWidth - 1);
end;


function  TROIFrm.XCursorDataToBitmap(xData: integer): integer;
begin
   Result := Muldiv(xData - xLeft, bitmapWidth - 1, xWidth - 1);
end;


function  TROIFrm.YBitmapToData(yBitmap: integer): integer;
begin
   Result := yTop - MulDiv(yBitmap, yHeight - 1, bitmapHeight - 1);
end;


function  TROIFrm.YDataToBitmap(yData: integer): integer;
begin
   Result := MulDiv(- yData + yTop, bitmapHeight - 1, yHeight - 1);
end;


{****************************** FORM EVENTS ***********************************}

procedure TROIFrm.FormCreate(Sender: TObject);
begin
   HorzTrackBar1 := THorzTrackBar.Create(self);
   HorzTrackBar1.Parent := self;
   HorzTrackBar1.OnChange := HorzTrackBar1Change;

   VertTrackBar1 := TVertTrackBar.Create(self);
   VertTrackBar1.Parent := self;
   VertTrackBar1.OnChange := VertTrackBar1Change;

   f_MAX_Y_VALUE := 2047;
   offscreenBitmap := TBitmap.Create;
   offscreenBitmap.handleType := bmDDB;

   xLeft := 0;
   xWidth := dataSize;
   yTop := f_MAX_Y_VALUE;
   yHeight := f_MAX_Y_VALUE * 2 + 1;

   cXTickMarks := 5;
   cYTickMarks := 5;
   prev_xLeft := xLeft;
   prev_xWidth := xWidth;
   prev_yTop := yTop;
   prev_yHeight := yHeight;
end;


procedure TROIFrm.FormResize(Sender: TObject);
begin
   ResizeElements;
   AdjustCursorPos;
   bInitialized := True;
   Invalidate;
end;


procedure TROIFrm.FormPaint(Sender: TObject);
var    rc, interRect: TRect;
begin
   if not bInitialized then Exit;
   rc := Canvas.ClipRect;
   Canvas.Brush.Color := clBtnFace;
   Canvas.Pen.Color := clBlack;
   Canvas.Pen.Mode := pmCopy;
   Canvas.Pen.Style := psSolid;

   if IntersectRect(interRect, rc, cornerRect) then
       Canvas.FillRect(cornerRect);

   if IntersectRect(interRect, rc, xAxisRect) or IntersectRect(interRect, rc, yAxisRect) then
       DrawAxis;

   if IntersectRect(interRect, rc, viewRect) then
   begin
       RedrawOffscreen;
       Canvas.CopyRect(interRect, offscreenBitmap.Canvas, RectWindowToBitmap(interRect));
   end;
end;



{*********************************** MENUS ************************************}

procedure TROIFrm.XAxis1Click(Sender: TObject);
begin
   ROIAxisDlg := TROIAxisDlg.Create(self);
   try
       ROIAxisDlg.ROIfrm := self;
       ROIAxisDlg.PageControl1.ActivePageIndex := 0;
       if ROIAxisDlg.ShowModal = mrOK then
           OnMagnificationChanged;
   finally
       ROIAxisDlg.Free;
   end;
end;


procedure TROIFrm.YAxis1Click(Sender: TObject);
begin
   ROIAxisDlg := TROIAxisDlg.Create(self);
   try
       ROIAxisDlg.ROIfrm := self;
       ROIAxisDlg.PageControl1.ActivePageIndex := 1;
       if ROIAxisDlg.ShowModal = mrOK then
           OnMagnificationChanged;
   finally
       ROIAxisDlg.Free;
   end;
end;


procedure TROIFrm.YAxisAutoscale1Click(Sender: TObject);
begin
   YAxisAutoscale1.Checked := not YAxisAutoscale1.Checked;
end;


procedure TROIFrm.XAxisFullRange1Click(Sender: TObject);
begin
   xLeft := 0;
   xWidth := dataSize;
   OnMagnificationChanged;
end;


procedure TROIFrm.YAxisFullRange1Click(Sender: TObject);
begin
   yTop :=  f_MAX_Y_VALUE;
   yHeight := 2 * (f_MAX_Y_VALUE + 1);
   OnMagnificationChanged;
end;


procedure TROIFrm.PreviousMagnification1Click(Sender: TObject);
begin
    xLeft := prev_xLeft;
    xWidth := prev_xWidth;
    yTop := prev_yTop;
    yHeight := prev_yHeight;
    OnMagnificationChanged;
end;


procedure TROIFrm.ResetCursorRelativeOrigins1Click(Sender: TObject);
begin
   refXCursorPos := xCursorPos;
   refYCursorPos := yCursorPos;
   UpdateCursorCaptions;
end;


procedure TROIFrm.Copydatatoclipboard1Click(Sender: TObject);
type   TCharArray = array[0..Maxint div 2] of Char;
var    i: integer;
       memhandle: THandle;
       pString: ^TCharArray;
       swLength, stringindex: integer;
       s1: string;
       sw: array[0..79] of WideChar;
begin
   try
       Clipboard.Open;
       Clipboard.Clear;

       {fills string with data; 11 digits for each column - each digit is a wide char}

       memHandle := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE or GMEM_ZEROINIT,
       	SizeOf(WideChar) * 25 {2 columns of 11 digits + TAB + CRLF} * dataSize + 1);

       pString := GlobalLock(memHandle);
       stringindex := 0;

       for i := 0 to dataSize - 1 do
       begin
           s1 := Format('%.6f', [(fromFrame + i)/FrameRate]) + TAB;
           swLength := 2 * Length(s1);

           CopyMemory(@(pString^[stringIndex]), StringToWideChar(s1, @sw, 80), swLength);
           stringIndex := stringIndex + swLength; {points to the next character}

           s1 := IntToStr(dataBuffer[i]) + CRLF;
           swLength := 2 * Length(s1);
           CopyMemory(@(pString^[stringIndex]), StringToWideChar(s1, @sw, 80), swLength);
           stringIndex := stringIndex + swLength; {points to the next character}
       end;

       Clipboard.SetAsHandle(CF_UNICODETEXT, memHandle);
   finally
       Clipboard.Close;
   end;
end;


{****************************** PUBLIC METHODS *********************************}


procedure TROIFrm.SavePrevMag;
begin
    prev_xLeft := xLeft;
    prev_xWidth := xWidth;
    prev_yTop := yTop;
    prev_yHeight := yHeight;
end;


procedure TROIFrm.SaveDataToFile(bASCII: boolean; padding: integer; filename: string);
var    i, paddingIndex: integer;
		fileStream: TFileStream;
       swLength: integer;
       s1: string;
       sw: array[0..179] of WideChar;
begin
   fileStream := TFileStream.Create(filename, fmCreate or fmShareExclusive);

   try
   	fileStream.Seek(0, soFromBeginning);
   {fills string with data; 11 digits for each column - each digit is a wide char, 2 columns}
   {number of rows is (toFrame - fromFrame + 1) * ChDataPtsPerFrame[]}
   {frameIndex: 0 to toFrame - fromFrame}
   {time in s for each frame: (fromFrame + frameIndex) * FrameSize * PixelClock * 1e-6 }
   {sampleIndex: 0 to ChDataPtsPerFrame[] - 1}
   {for each sample: sampleIndex * FrameSize * PixelClock * 1e-6 / ChDataPtsPerFrame[]}

       for i := 0 to dataSize - 1 do
       	for paddingIndex := 0 to padding - 1 do
           begin
           	s1 := Format('%.6f', [(fromFrame + i + paddingIndex/padding)/FrameRate]) + TAB + IntToStr(dataBuffer[i]) + CRLF;

               if bASCII then
               	fileStream.Write(s1[1], Length(s1))
               else
               begin
               	swLength := 2 * Length(s1); {Unicode business}
               	StringToWideChar(s1, @sw, swLength + 1);
               	fileStream.Write(sw, swLength);
               end;
           end;

   finally
   	fileStream.Free;
   end;
end;


{*********************************** EVENTS ***********************************}

procedure TROIFrm.HorzTrackBar1Change(Sender: TObject);
begin
   if not bAdjustingCursorPos then
   begin
       {draw}
       DrawXCursorOnBitmap; {erases prev cursor}
       DrawXCursorOnScreen; {gone!}
       xCursorPos := xBitmapToData(HorzTrackBar1.Position);
       DrawXCursorOnBitmap;
       DrawXCursorOnScreen;
       UpdateCursorCaptions;
   end;
end;


procedure TROIFrm.VertTrackBar1Change(Sender: TObject);
begin
   if not bAdjustingCursorPos then
   begin
       {draw}
       DrawYCursorOnBitmap; {erases prev cursor}
       DrawYCursorOnScreen; {gone!}
       yCursorPos := yBitmapToData(vertTrackBar1.Max - vertTrackBar1.Position);
       DrawYCursorOnBitmap;
       DrawYCursorOnScreen;
       UpdateCursorCaptions;
   end;
end;


procedure TROIFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
end;


procedure TROIFrm.FormDestroy(Sender: TObject);
begin
   offscreenBitmap.Free;
end;


procedure TROIFrm.CopydatatoclipboardasTEXT1Click(Sender: TObject);
type   TCharArray = array[0..Maxint div 2] of Char;
var    i: integer;
       memhandle: THandle;
       pString: ^TCharArray;
       swLength, stringindex: integer;
       s1: string;
begin
   try
       Clipboard.Open;
       Clipboard.Clear;

       {fills string with data; 11 digits for each column - each digit is a wide char}

       memHandle := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE or GMEM_ZEROINIT,
       	25 {2 columns of 11 digits + TAB + CRLF} * dataSize + 1);

       pString := GlobalLock(memHandle);
       stringindex := 0;

       for i := 0 to dataSize - 1 do
       begin
           s1 := Format('%.6f', [(fromFrame + i)/FrameRate]) + TAB;
           swLength := Length(s1);

           CopyMemory(@(pString^[stringIndex]), @s1[1], swLength);
           stringIndex := stringIndex + swLength; {points to the next character}

           s1 := IntToStr(dataBuffer[i]) + CRLF;
           swLength := Length(s1);
           CopyMemory(@(pString^[stringIndex]), @s1[1], swLength);
           stringIndex := stringIndex + swLength; {points to the next character}
       end;

       Clipboard.SetAsHandle(CF_TEXT, memHandle);
   finally
       Clipboard.Close;
   end;
end;

end.
