unit StatDlgu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Mask, Buttons, MPFileu;

type
  TStatDlg = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SpeedButton1: TSpeedButton;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    MaskEdit3: TMaskEdit;
    MaskEdit4: TMaskEdit;
    Label11: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Bevel4: TBevel;
    Label15: TLabel;
    Label16: TLabel;
    Bevel5: TBevel;
    Label17: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    fMPFile: TMPFile;
    fchIndex: integer;
    fFrameIndex: integer;
    procedure RefreshStats;
  public
    { Public declarations }
    procedure Initialize(ampFile: TMPFile; framenumber, channelnumber: integer;
    	areaRC: TRect);
  end;

var
  StatDlg: TStatDlg;

implementation

{$R *.DFM}
uses MPViewu;

procedure TStatDlg.RefreshStats;
var	rc: TRect;
		x, y, value: integer;
begin
	try
		rc.Left := StrToInt(MaskEdit1.Text);
		rc.Top := StrToInt(MaskEdit2.Text);
		rc.Right := StrToInt(MaskEdit3.Text);
		rc.Bottom := StrToInt(MaskEdit4.Text);
   	if (rc.Left >= 0) and (rc.Left < fMPFile.FrameWidth) and (rc.Top >= 0) and
   		(rc.Top < fMPFile.FrameHeight) and (rc.Right >= 0) and (rc.Right < fMPFile.FrameWidth) and
       	(rc.Bottom >= 0) and (rc.Bottom < fMPFile.FrameHeight) then
		begin
       	NormalizeRect(rc);
			value := fMPFile.GetAverage(fFrameIndex, fChIndex, rc);
           Label11.Caption := IntToStr(value);
           value := fMPFile.GetMax(fFrameIndex, fChIndex, rc, x, y);
           Label12.Caption := IntToStr(value);
           Label13.Caption := 'X = ' + IntToStr(x) + ', Y = ' + IntToStr(y);
           value := fMPFile.GetMin(fFrameIndex, fChIndex, rc, x, y);
           Label15.Caption := IntToStr(value);
           Label17.Caption := 'X = ' + IntToStr(x) + ', Y = ' + IntToStr(y);
       end
   	else
       	MessageDlg('Area Parameters Out Of Bounds.', mtError, [mbOK], 0);
   except
   	MessageDlg('Invalid Area Parameters.', mtError, [mbOK], 0);
   end;
end;


procedure TStatDlg.Initialize(ampFile: TMPFile; framenumber, channelnumber: integer;
    	areaRC: TRect);
begin
	fMPFile := ampFile;
   fChIndex := channelNumber;
   fFrameIndex := frameNumber;
   Label6.Caption := IntToStr(fChIndex);
   MaskEdit1.Text := IntToStr(areaRC.Left);
   MaskEdit2.Text := IntToStr(areaRC.Top);
   MaskEdit3.Text := IntToStr(areaRC.Right);
   MaskEdit4.Text := IntToStr(areaRC.Bottom);
   RefreshStats;
end;


procedure TStatDlg.SpeedButton1Click(Sender: TObject);
begin
	RefreshStats;
end;

end.
