unit binfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Spin;

type
  TBinOpForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    SpinEdit1: TSpinEdit;
    Edit1: TEdit;
    TrackBar1: TTrackBar;
    BitBtn1: TBitBtn;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ComboBox2: TComboBox;
    SpinEdit2: TSpinEdit;
    Edit2: TEdit;
    TrackBar2: TTrackBar;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    ComboBox3: TComboBox;
    Label8: TLabel;
    Bevel1: TBevel;
    Label9: TLabel;
    SpeedButton1: TSpeedButton;
    BitBtn2: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
    function	Frames12Compatible: boolean;
    function	Frames123Compatible: boolean;
  public
    { Public declarations }
    resultFrameIndex: integer;
  end;

var
  BinOpForm: TBinOpForm;

implementation

{$R *.DFM}

Uses Mainfrm, MPViewu, MPFileu;

function	TBinOpForm.Frames12Compatible: boolean;
var	file1, file2: TMPFile;
begin
	file1 := TMPFile(ComboBox1.Items.Objects[ComboBox1.ItemIndex]);
	file2 := TMPFile(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
   Result := 	(file1.Resolution = file2.Resolution) and
				(file1.FrameWidth = file2.FrameWidth) and
       		(file1.FrameHeight = file2.FrameHeight);
end;


function	TBinOpForm.Frames123Compatible: boolean;
var	file1, file2, resultFile: TMPFile;
		frame1, frame2: integer;
begin
	file1 := TMPFile(ComboBox1.Items.Objects[ComboBox1.ItemIndex]);
	file2 := TMPFile(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
	resultFile := TMPFile(ComboBox3.Items.Objects[ComboBox3.ItemIndex]);
   frame1 := SpinEdit1.Value - 1;
   frame2 := SpinEdit2.Value - 1;

	Result := Frames12Compatible and
   	(resultFrameIndex <> -1) and
//       (resultFile.Resolution = file1.Resolution) and
       (resultFile.FrameWidth = file1.FrameWidth) and
       (resultFile.FrameHeight = file1.FrameHeight) and
       (frame1 >= 0) and (frame1 < file1.FrameCount) and
       (frame2 >= 0) and (frame2 < file2.FrameCount) and
       (resultFrameIndex >= 0) and (resultFrameIndex < resultFile.FrameCount);
end;


procedure TBinOpForm.BitBtn1Click(Sender: TObject);
begin
	Close;
end;


procedure TBinOpForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Mainform.bBinaryOp := False;
   Action := caFree;
end;


procedure TBinOpForm.FormCreate(Sender: TObject);
var 	i: integer;
		s: string;
begin
	resultFrameIndex := -1;
	for i := 0 to Mainform.fileList.Count - 1 do
   begin
   	s := Mainform.fileList.Strings[i];
       if not TMPFile(Mainform.fileList.Objects[i]).IsMemoryFile then
   		s := ExtractFileName(s);
		ComboBox1.Items.AddObject(s, Mainform.fileList.Objects[i]);
		ComboBox2.Items.AddObject(s, Mainform.fileList.Objects[i]);
       if TMPFile(Mainform.fileList.Objects[i]).IsMemoryFile then
			ComboBox3.Items.AddObject(s, Mainform.fileList.Objects[i]);
   end;
	ComboBox1.ItemIndex := 0;
   ComboBox2.ItemIndex := 0;
   ComboBox3.ItemIndex := 0;
end;

procedure TBinOpForm.TrackBar2Change(Sender: TObject);
begin
	Edit2.Text := FloatToStr(TrackBar2.Position / 10);
end;


procedure TBinOpForm.TrackBar1Change(Sender: TObject);
begin
	Edit1.Text := FloatToStr(TrackBar1.Position / 10);
end;


procedure TBinOpForm.ComboBox1Change(Sender: TObject);
begin
   if ComboBox1.ItemIndex >= 0 then
		with TMPFile(ComboBox1.Items.Objects[ComboBox1.ItemIndex]) do
       begin
       	RadioButton1.Checked := (DefaultVideoChannel = 0);
       	RadioButton2.Checked :=  not (DefaultVideoChannel = 1);
       	RadioButton5.Checked :=  not (DefaultVideoChannel = 2);
       	RadioButton6.Checked :=  not (DefaultVideoChannel = 3);

           if VideoChCount = 1 then
           begin
           	RadioButton1.Enabled := False;
           	RadioButton2.Enabled := False;
           	RadioButton5.Enabled := False;
           	RadioButton6.Enabled := False;
           end
           else
           begin
           	RadioButton1.Enabled := VideoChEnabled[0];
           	RadioButton2.Enabled := VideoChEnabled[1];
           	RadioButton5.Enabled := VideoChEnabled[2];
           	RadioButton6.Enabled := VideoChEnabled[3];
           end;
       end;
end;

procedure TBinOpForm.ComboBox2Change(Sender: TObject);
begin
   if ComboBox2.ItemIndex >= 0 then
		with TMPFile(ComboBox2.Items.Objects[ComboBox2.ItemIndex]) do
       begin
       	RadioButton3.Checked := (DefaultVideoChannel = 0);
       	RadioButton4.Checked :=  not (DefaultVideoChannel = 0);
       	RadioButton7.Checked :=  not (DefaultVideoChannel = 2);
       	RadioButton8.Checked :=  not (DefaultVideoChannel = 3);

           if VideoChCount = 1 then
           begin
           	RadioButton3.Enabled := False;
           	RadioButton4.Enabled := False;
           	RadioButton7.Enabled := False;
           	RadioButton8.Enabled := False;
           end
           else
			begin
           	RadioButton3.Enabled := VideoChEnabled[0];
           	RadioButton4.Enabled := VideoChEnabled[1];
           	RadioButton7.Enabled := VideoChEnabled[2];
           	RadioButton8.Enabled := VideoChEnabled[3];
           end;
       end;
end;


procedure TBinOpForm.FormShow(Sender: TObject);
begin
	ComboBox1Change(nil);
	ComboBox2Change(nil);
end;


procedure TBinOpForm.SpeedButton1Click(Sender: TObject);
var	resultFile, file1: TMPFile;
begin
	resultFile := TMPFile(ComboBox3.Items.Objects[ComboBox3.ItemIndex]);
	file1 := TMPFile(ComboBox1.Items.Objects[ComboBox1.ItemIndex]);
	{Prerequisitites}
   if Frames12Compatible then
   begin
		ResultFrameIndex := resultFile.CreateEmptyFrame(file1);
       Label9.Caption := IntToStr(ResultFrameIndex + 1);
   end
   else
   	MessageDlg('Frame 1 and Frame 2 are incompatible.', mtError, [mbOK], 0);
end;


procedure TBinOpForm.BitBtn2Click(Sender: TObject);
var	file1, file2, resultFile: TMPFile;
		ch1, ch2, frame1, frame2: integer;
       gain1, gain2: double;
begin
	file1 := TMPFile(ComboBox1.Items.Objects[ComboBox1.ItemIndex]);
	file2 := TMPFile(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
	resultFile := TMPFile(ComboBox3.Items.Objects[ComboBox3.ItemIndex]);
   frame1 := SpinEdit1.Value - 1;
   frame2 := SpinEdit2.Value - 1;

	if RadioButton1.Checked then
   	ch1 := 0
   else if RadioButton2.Checked then
   	ch1 := 1
   else if RadioButton5.Checked then
		ch1 := 2
   else
   	ch1 := 3;

	if RadioButton3.Checked then
   	ch2 := 0
   else if RadioButton4.Checked then
       ch2 := 1
   else if RadioButton7.Checked then
       ch2 := 2
   else
   	ch2 := 3;

	gain1 := StrToFloat(Edit1.Text);
	gain2 := StrToFloat(Edit2.Text);

   if Frames123Compatible then
   	resultFile.BinaryOp(file1, file2, ch1, ch2, frame1, frame2, gain1, gain2, resultFrameIndex)
   else
   	MessageDlg('Invalid binary operation parameter(s).', mtError, [mbOK], 0);
end;

end.
