unit lutdlgu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, Spin, Vieweru, MPViewu;

type
  TLUTDlg = class(TForm)
    TabControl1: TTabControl;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    PaintBox1: TPaintBox;
    GroupBox2: TGroupBox;
    SpeedButton1: TSpeedButton;
    PaintBox2: TPaintBox;
    GroupBox3: TGroupBox;
    SpeedButton2: TSpeedButton;
    PaintBox3: TPaintBox;
    GroupBox4: TGroupBox;
    SpeedButton3: TSpeedButton;
    PaintBox4: TPaintBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    ColorDialog1: TColorDialog;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox4Paint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
  private
    { Private declarations }
    bDontChange: boolean;
  public
    { Public declarations }
    dlgBaseColors: TBaseColorsArray;
    dlgnegativeColors,
    dlgmidRangeColors,
    dlgmaxColors: TRangeColorsArray;
    dlgMaxPixels: TMaxPixelsArray;
    viewer: TViewerFrm;
  end;

var
  LUTDlg: TLUTDlg;

implementation

{$R *.DFM}

uses Mainfrm;

procedure TLUTDlg.CheckBox1Click(Sender: TObject);
var	r,g,b: Byte;
begin
	r := 0; g := 0; b := 0;

	if not bDontChange then
   begin
		dlgBaseColors[TabControl1.TabIndex, 0] := CheckBox1.Checked;
		dlgBaseColors[TabControl1.TabIndex, 1] := CheckBox2.Checked;
		dlgBaseColors[TabControl1.TabIndex, 2] := CheckBox3.Checked;
   end;

   if SpinEdit1.Value >= SpinEdit2.Value then
   	PaintBox1.Color := RGB(dlgmaxColors[TabControl1.TabIndex].rgbtRed,
			dlgmaxColors[TabControl1.TabIndex].rgbtGreen,
           dlgmaxColors[TabControl1.TabIndex].rgbtBlue)
   else
   begin
   	if CheckBox1.Checked then r := Muldiv($FF, SpinEdit1.Value, SpinEdit2.Value - 1);
   	if CheckBox2.Checked then g := Muldiv($FF, SpinEdit1.Value, SpinEdit2.Value - 1);
   	if CheckBox3.Checked then b := Muldiv($FF, SpinEdit1.Value, SpinEdit2.Value - 1);
   	PaintBox1.Color := RGB(r, g, b);
   end;

   PaintBox1.Invalidate;
end;


procedure TLUTDlg.SpeedButton1Click(Sender: TObject);
begin
	ColorDialog1.Color :=  RGB( dlgnegativeColors[TabControl1.TabIndex].rgbtRed,
   							dlgnegativeColors[TabControl1.TabIndex].rgbtGreen,
                               dlgnegativeColors[TabControl1.TabIndex].rgbtBlue);
	if ColorDialog1.Execute then
   begin
   	{TRGBQuad has order of R, G, B reversed}
		dlgnegativeColors[TabControl1.TabIndex].rgbtRed := TRGBQuad(ColorDialog1.Color).rgbBlue;
		dlgnegativeColors[TabControl1.TabIndex].rgbtGreen := TRGBQuad(ColorDialog1.Color).rgbGreen;
		dlgnegativeColors[TabControl1.TabIndex].rgbtBlue := TRGBQuad(ColorDialog1.Color).rgbRed;
       PaintBox2.Color := ColorDialog1.Color;
       PaintBox2.Invalidate;
   end;
end;


procedure TLUTDlg.BitBtn1Click(Sender: TObject);
var	i: integer;
begin
	if  (dlgBaseColors[0, 0] or dlgBaseColors[0, 1] or dlgBaseColors[0, 2] = False) or
		(dlgBaseColors[1, 0] or dlgBaseColors[1, 1] or dlgBaseColors[1, 2] = False) or
		(dlgBaseColors[2, 0] or dlgBaseColors[2, 1] or dlgBaseColors[2, 2] = False) or
		(dlgBaseColors[3, 0] or dlgBaseColors[3, 1] or dlgBaseColors[3, 2] = False) then
   begin
   	MessageDlg('Base colors cannot be black.', mtError, [mbOK], 0);
       ModalResult := mrNone;
   end
   else
		with Viewer.mpFile do
   	begin
			BaseColors := dlgBaseColors;
			negativeColors := dlgnegativeColors;
			midRangeColors := dlgmidRangeColors;
			maxColors := dlgmaxColors;
           for i := 0 to MAX_CH - 1 do
           	if dlgMaxPixels[i] > 2047 then dlgMaxPixels[i] := 2047
               else if dlgMaxPixels[i] < 50 then dlgMaxPixels[i] := 50;
           maxPixels := dlgMaxPixels;
   	end;
end;


procedure TLUTDlg.TabControl1Change(Sender: TObject);
begin
	bDontChange := True;
	CheckBox1.Checked := dlgBaseColors[TabControl1.TabIndex, 0];
	CheckBox2.Checked := dlgBaseColors[TabControl1.TabIndex, 1];
	CheckBox3.Checked := dlgBaseColors[TabControl1.TabIndex, 2];

   PaintBox2.Color := RGB(	dlgnegativeColors[TabControl1.TabIndex].rgbtRed,
							dlgnegativeColors[TabControl1.TabIndex].rgbtGreen,
                           dlgnegativeColors[TabControl1.TabIndex].rgbtBlue);
   PaintBox3.Color := RGB(	dlgmidRangeColors[TabControl1.TabIndex].rgbtRed,
   						dlgmidRangeColors[TabControl1.TabIndex].rgbtGreen,
                           dlgmidRangeColors[TabControl1.TabIndex].rgbtBlue);
   PaintBox4.Color := RGB( dlgmaxColors[TabControl1.TabIndex].rgbtRed,
   						dlgmaxColors[TabControl1.TabIndex].rgbtGreen,
                           dlgmaxColors[TabControl1.TabIndex].rgbtBlue);

	SpinEdit2.Value := dlgMaxPixels[TabControl1.TabIndex];

   CheckBox1Click(nil);
   PaintBox1.Invalidate;
   PaintBox2.Invalidate;
   PaintBox3.Invalidate;
   PaintBox4.Invalidate;
	bDontChange := False;
end;


procedure TLUTDlg.SpeedButton2Click(Sender: TObject);
begin
	ColorDialog1.Color :=  RGB( dlgmidRangeColors[TabControl1.TabIndex].rgbtRed,
   							dlgmidRangeColors[TabControl1.TabIndex].rgbtGreen,
                               dlgmidRangeColors[TabControl1.TabIndex].rgbtBlue);
	if ColorDialog1.Execute then
   begin
   	dlgmidRangeColors[TabControl1.TabIndex].rgbtRed := TRGBQuad(ColorDialog1.Color).rgbBlue;
   	dlgmidRangeColors[TabControl1.TabIndex].rgbtGreen := TRGBQuad(ColorDialog1.Color).rgbGreen;
   	dlgmidRangeColors[TabControl1.TabIndex].rgbtBlue := TRGBQuad(ColorDialog1.Color).rgbRed;
       PaintBox3.Color := ColorDialog1.Color;
       PaintBox3.Invalidate;
   end;
end;


procedure TLUTDlg.SpeedButton3Click(Sender: TObject);
begin
	ColorDialog1.Color :=  RGB( dlgmaxColors[TabControl1.TabIndex].rgbtRed,
   							dlgmaxColors[TabControl1.TabIndex].rgbtGreen,
                               dlgmaxColors[TabControl1.TabIndex].rgbtBlue);
	if ColorDialog1.Execute then
   begin
   	dlgmaxColors[TabControl1.TabIndex].rgbtRed := TRGBQuad(ColorDialog1.Color).rgbBlue;
   	dlgmaxColors[TabControl1.TabIndex].rgbtGreen := TRGBQuad(ColorDialog1.Color).rgbGreen;
   	dlgmaxColors[TabControl1.TabIndex].rgbtBlue := TRGBQuad(ColorDialog1.Color).rgbRed;
       PaintBox4.Color := ColorDialog1.Color;
       PaintBox4.Invalidate;
   end;
end;


procedure TLUTDlg.PaintBox1Paint(Sender: TObject);
begin
   with PaintBox1, PaintBox1.Canvas do
   begin
       Brush.Color := Color;
       FillRect(ClientRect);
   end;
end;


procedure TLUTDlg.PaintBox2Paint(Sender: TObject);
begin
   with PaintBox2, PaintBox2.Canvas do
   begin
       Brush.Color := Color;
       FillRect(ClientRect);
   end;
end;


procedure TLUTDlg.PaintBox4Paint(Sender: TObject);
begin
   with PaintBox4, PaintBox4.Canvas do
   begin
       Brush.Color := Color;
       FillRect(ClientRect);
   end;
end;


procedure TLUTDlg.FormShow(Sender: TObject);
begin
   TabControl1.TabIndex := Viewer.MPFile.DefaultVideoChannel;
   TabControl1Change(nil);
   CheckBox1Click(nil);
end;


procedure TLUTDlg.PaintBox3Paint(Sender: TObject);
begin
   with PaintBox3, PaintBox3.Canvas do
   begin
       Brush.Color := Color;
       FillRect(ClientRect);
   end;
end;

procedure TLUTDlg.SpinEdit2Change(Sender: TObject);
begin
	dlgMaxPixels[TabControl1.TabIndex] := SpinEdit2.Value;
   CheckBox1Click(nil);
end;


procedure TLUTDlg.TabControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
	dlgBaseColors[TabControl1.TabIndex, 0] := CheckBox1.Checked;
	dlgBaseColors[TabControl1.TabIndex, 1] := CheckBox2.Checked;
	dlgBaseColors[TabControl1.TabIndex, 2] := CheckBox3.Checked;
end;

end.
