unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, ToolWin, ComCtrls, mpviewu, Buttons, ExtCtrls, mpfileu,
  COMObj, ActiveX, ShellAPI, ROIFrmu;

const
	WM_POSTSHOWMSG = WM_APP + 400;

type
  TMainform = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    NewFile1: TMenuItem;
    OpenFile1: TMenuItem;
    SaveFileAs1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    FileInformation1: TMenuItem;
    N5: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Settings1: TMenuItem;
    Options1: TMenuItem;
    StopMatlab1: TMenuItem;
    SpeedButton2: TSpeedButton;
    Window1: TMenuItem;
    N3: TMenuItem;
    ArrangeAll1: TMenuItem;
    Cascade1: TMenuItem;
    Tile1: TMenuItem;
    FileAs1: TMenuItem;
    AnalogDataAs1: TMenuItem;
    ROIDataAs1: TMenuItem;
    Scripting1: TMenuItem;
    ShowScriptingEnvironment1: TMenuItem;
    Panel2: TPanel;
    AnalogTraceAsMetafile1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenFile1Click(Sender: TObject);
    procedure NewFile1Click(Sender: TObject);
    procedure SaveFileAs1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure StopMatlab1Click(Sender: TObject);
    procedure FileInformation1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeAll1Click(Sender: TObject);
    procedure AnalogDataAs1Click(Sender: TObject);
    procedure ROIDataAs1Click(Sender: TObject);
    procedure AnalogTraceAsMetafile1Click(Sender: TObject);
  private
    { Private declarations }
    procedure InitializeColorTables;
    function  GetActiveFile: TObject; {returns the file associated with the MDI window}
  public
    { Public declarations }
    {24-bit gray scale or false color table}
    grayScaleTable, falseColorTable: array[0..MAX_FALSE_COLORS-1] of TRGBTriple;

    bAppClosing,
    bBinaryOp,
    bLocalMatlabServer: boolean;
    remoteMatlabServer: string;
    matlab : OleVariant;
    fileList: TFileList;

	 procedure WMDROPFILES(var Message: TMessage); message WM_DROPFILES;
	 procedure WMPOSTSHOWMSG(var Message: TMessage); message WM_POSTSHOWMSG;

    property activeFile: TObject read GetActiveFile;
  end;

var
  Mainform: TMainform;

implementation

{$R *.DFM}

uses RegStr, Registry, Optdlgu, Fileinfodlgu, vieweru, aboutdlgu, mconsolefrm, Math,
   analogu, vfw, {Variants,} cpyanaldlgu, FileCtrl;

const
   sSection = 'Application Settings';
   sEntry = 'Position';
   sDirectory = 'Data Directory';
   sbLocalServer = 'Local Server';
   sRemoteServerLocation = 'Remote Server';
   sAppName = 'MPView';


{******************************** Private methods *****************************}

procedure TMainform.InitializeColorTables;
var    i, n, g, r, b, offset: integer;
       u: array of integer;
       J: array[1..MAX_FALSE_COLORS,1..3] of integer;
begin
   {gray scales}
   for i := 0 to 2047 do
   begin
       grayScaleTable[i].rgbtBlue := i div 8;
       grayScaleTable[i].rgbtGreen := i div 8;
       grayScaleTable[i].rgbtRed := i div 8;
   end;

   {false colors}
   n := ceil(MAX_FALSE_COLORS / 4);
   SetLength(u, 3 * n - 1);
	for i := 0 to n-1 do u[i] := Muldiv(255,i + 1,n);
	for i := n to 2*n - 2 do u[i] := 255;
	for i := 2*n - 1 to 3*n - 2 do u[i] := Muldiv(255, 3*n - i + 1, n);

   if MAX_FALSE_COLORS mod 4 = 1 then g := -1 else g := 0;
   g := g + ceil(n/2) + 1; {g[1..3 * n - 1]}
   r := g + n;
   b := g - n;
   if b < 1 then offset := -b + 1 else offset := 0;

   for i := 1 to MAX_FALSE_COLORS do
   begin
       J[i, 1] := 0;
       J[i, 2] := 0;
       J[i, 3] := 0;
   end;

   for i := 1 to MAX_FALSE_COLORS do
   begin
	    if (i + r <= MAX_FALSE_COLORS) and (i < 3*n) then J[i + r ,1] := u[i-1];
	    if (i + g <= MAX_FALSE_COLORS) and (i < 3*n) then J[i + g, 2] := u[i-1];
	    if (i + offset <= 3*n - 1) then J[i,3] := u[i- 1 + offset];
   end;

   for i := 1 to MAX_FALSE_COLORS do
   begin
       if J[i, 1] > 255 then
           J[i, 1] := 255;
       if J[i, 2] > 255 then
           J[i, 2] := 255;
       if J[i, 3] > 255 then
           J[i, 3] := 255;
   end;

   for i := 1 to MAX_FALSE_COLORS - 1 do
   begin
       falseColorTable[i].rgbtBlue := J[i+1,3];
       falseColorTable[i].rgbtGreen := J[i+1,2];
       falseColorTable[i].rgbtRed := J[i+1,1];
   end;

   falseColorTable[MAX_FALSE_COLORS - 1].rgbtBlue := 255;
   falseColorTable[MAX_FALSE_COLORS - 1].rgbtGreen := 255;
   falseColorTable[MAX_FALSE_COLORS - 1].rgbtRed := 255;

   falseColorTable[0].rgbtBlue := 0;
   falseColorTable[0].rgbtGreen := 0;
   falseColorTable[0].rgbtRed := 0;
end;


function  TMainform.GetActiveFile: TObject; {returns the file associated with the MDI window}
begin
   Result := nil;
   if MDIChildCount > 0 then
       if MDIChildren[0] is TViewerFrm then
           Result := (MDIChildren[0] as TViewerFrm).MPFile
       else if MDIChildren[0] is TAnalogFrm then
           Result := (MDIChildren[0] as TAnalogFrm).MPFile;
end;


{********************************* PUBLIC *************************************}

procedure TMainform.WMDROPFILES(var Message: TMessage);
var	szFileName: array[0..255] of Char;
		fileCount, i: integer;
       s: string;
begin
	fileCount := DragQueryFile(HDROP(Message.wParam), $FFFFFFFF, nil, 256);

   try
		if fileCount > 0 then
			for i := 0 to fileCount - 1 do
           	if DragQueryFile(HDROP(Message.wParam), i, @szFileName, 256) > 0 then
               begin
               	s := szFileName;
					FileList.Open(s);
               end;
   finally
		DragFinish(HDROP(Message.wParam));
   end;
end;


procedure TMainform.WMPOSTSHOWMSG(var Message: TMessage);
begin
	if ParamCount > 0 then
   try
		FileList.Open(GetLongFilePath(ParamStr(1)));
	except
       OpenFile1Click(nil);
   end
   else
       OpenFile1Click(nil);
end;


{**************************** CREATION - DESTRUCTION **************************}

procedure TMainform.FormCreate(Sender: TObject);
var	reg: TRegistry;
	   	keyName, keyValue: string;
  		TempKey: HKey;
		Disposition: Integer;
begin
   AVIFileInit;
   InitializeColorTables;
   fileList := TFileList.Create;
   VariantInit(matlab);

   {Associates file extension: CODE DOES NOT WORK}

   {Opens root}
   	TempKey := 0;
    	keyName := '.mpd';
		if RegCreateKeyEx(HKEY_CLASSES_ROOT, PChar(keyName), 0, nil, REG_OPTION_NON_VOLATILE,
   	KEY_ALL_ACCESS, nil, TempKey, @Disposition) = ERROR_SUCCESS then
		begin
   		keyValue := 'MPView';
			RegSetValue(TempKey, nil, REG_SZ, PChar(keyValue), Length(keyValue));
			RegCloseKey(TempKey);
       end;

     	TempKey := 0;
      	keyName := 'MPView';
		if RegCreateKeyEx(HKEY_CLASSES_ROOT, PChar(keyName), 0, nil, REG_OPTION_NON_VOLATILE,
   	KEY_ALL_ACCESS, nil, TempKey, @Disposition) = ERROR_SUCCESS then
			RegCloseKey(TempKey);

     	TempKey := 0;
   	keyName := 'MPView\DefaultIcon';
		if RegCreateKeyEx(HKEY_CLASSES_ROOT, PChar(keyName), 0, nil, REG_OPTION_NON_VOLATILE,
   	KEY_ALL_ACCESS, nil, TempKey, @Disposition) = ERROR_SUCCESS then
		begin
   		keyValue := ParamStr(0) + ',0';
			RegSetValue(TempKey, nil, REG_SZ, PChar(keyValue), Length(keyValue));
			RegCloseKey(TempKey);
       end;

     	TempKey := 0;
      	keyName := 'MPView\Shell';
		if RegCreateKeyEx(HKEY_CLASSES_ROOT, PChar(keyName), 0, nil, REG_OPTION_NON_VOLATILE,
   	KEY_ALL_ACCESS, nil, TempKey, @Disposition) = ERROR_SUCCESS then
			RegCloseKey(TempKey);

     	TempKey := 0;
   	keyName := 'MPView\Shell\Open';
		if RegCreateKeyEx(HKEY_CLASSES_ROOT, PChar(keyName), 0, nil, REG_OPTION_NON_VOLATILE,
   	KEY_ALL_ACCESS, nil, TempKey, @Disposition) = ERROR_SUCCESS then
		begin
   		keyValue := '&Open';
			RegSetValue(TempKey, nil, REG_SZ, PChar(keyValue), Length(keyValue));
			RegCloseKey(TempKey);
       end;

     	TempKey := 0;
   	keyName := 'MPView\Shell\Open\Command';
		if RegCreateKeyEx(HKEY_CLASSES_ROOT, PChar(keyName), 0, nil, REG_OPTION_NON_VOLATILE,
   	KEY_ALL_ACCESS, nil, TempKey, @Disposition) = ERROR_SUCCESS then
		begin
   		keyValue := ParamStr(0) + ' %1';
			RegSetValue(TempKey, nil, REG_SZ, PChar(keyValue), Length(keyValue));
			RegCloseKey(TempKey);
       end;

	reg := TRegistry.Create;
   with reg do
   try
   	RootKey := HKEY_CURRENT_USER;
       if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Extensions', True)
    	   	then if ReadString('MPD') = '' then
           	WriteString('MPD', ParamStr(0));
   	CloseKey;
   finally
       Free;
   end;

   {Drag and Drop}
   DragAcceptFiles(Handle, True);
end;


procedure TMainform.FormShow(Sender: TObject);
var    regini: TRegistryIniFile;
begin
   regini := TRegistryIniFile.Create(sAppName);
   with regini do
   begin
       FileList.dataDirectory :=  ExcludeTrailingBackslash(ReadString(sSection, sDirectory, ''));
       bLocalMatlabServer := ReadBool(sSection, sbLocalServer, True);
       remoteMatlabServer := ReadString(sSection, sRemoteServerLocation, '');
       if not DirectoryExists(FileList.dataDirectory) then
           fileList.dataDirectory := ExcludeTrailingBackslash(ExtractFilePath(ParamStr(0)));
       RestorePosFromRegistry(self, regini, sSection, sEntry, True);
       Free;
   end;

   PostMessage(Handle, WM_POSTSHOWMSG, 0, 0);
end;


procedure TMainform.FormClose(Sender: TObject; var Action: TCloseAction);
var    regini: TRegistryIniFile;
begin
   regini := TRegistryIniFile.Create(sAppName);
   with regini do
   begin
       WriteBool(sSection, sbLocalServer, bLocalMatlabServer);
       WriteString(sSection, sRemoteServerLocation, remoteMatlabServer);
       WriteString(sSection, sDirectory, FileList.dataDirectory);
       SavePosToRegistry(self, regini, sSection, sEntry);
       Free;
   end;

   {Drag and Drop}
   DragAcceptFiles(Handle, False);
end;


procedure TMainform.FormDestroy(Sender: TObject);
begin
   fileList.Free;
   AVIFileExit;
end;


{************************************ MENUS ***********************************}

procedure TMainform.NewFile1Click(Sender: TObject);
begin
   if ActiveFile <> nil then
       fileList.NewFile(ActiveFile as TMPFile);
end;


procedure TMainform.OpenFile1Click(Sender: TObject);
begin
   OpenDialog1.InitialDir := ExcludeTrailingBackslash(FileList.dataDirectory);
   if OpenDialog1.Execute then
       FileList.Open(OpenDialog1.Filename);
end;


procedure TMainform.SaveFileAs1Click(Sender: TObject);
begin
   if MDIChildCount > 0 then
       if MDIChildren[0] is TViewerFrm then
           if (MDIChildren[0] as TViewerFrm).mpFile.IsMemoryFile then
           begin
               if (MDIChildren[0] as TViewerFrm).mpFile.FrameCount > 0 then
               begin
               	with SaveDialog1 do
                   begin
                   	DefaultExt := 'MPD';
                       Filter := 'MPD Files (*.MPD)|*.MPD|All Files (*.*)|*.*';
                       Title := 'Save Workspace As';
                   end;
                   if SaveDialog1.Execute then
                       fileList.SaveFileAs
                       ((MDIChildren[0] as TViewerFrm).MPFile, SaveDialog1.Filename);
               end
               else
                   MessageDlg('Workspace ' + (MDIChildren[0] as TViewerFrm).mpFile.Filename +
                       ' has no frames to save.', mtInformation, [mbOK], 0);
           end;
   {    else if MDIChildren[0] is TAnalogFrm then
       begin
       end
       else if MDIChildren[0] is TROIFrm then
       begin
       end; }
end;



procedure TMainform.AnalogDataAs1Click(Sender: TObject);
var	fromFrame, toFrame: integer;
		savedCursor: TCursor;
       bASCII: boolean;
begin
   if MDIChildCount > 0 then
       if MDIChildren[0] is TAnalogFrm then
       	if (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount > 0 then
           begin
           	bASCII := (MessageDlg('Do you want to save the file as plain ASCII (Yes) or Unicode (No)?',
               	mtInformation, [mbYes, mbNo], 0)= mrYes);

           	{strange - "with" construct with CopyAnalogDlg or (MDIChildren[0] fail at run-time)}
           	CopyAnalogDlg.RadioButton1.Checked :=  (MDIChildren[0] as TAnalogFrm).mpFile.AnalogChEnabled[2];
               CopyAnalogDlg.RadioButton1.Enabled := (MDIChildren[0] as TAnalogFrm).mpFile.AnalogChEnabled[2];
               CopyAnalogDlg.RadioButton2.Checked := (MDIChildren[0] as TAnalogFrm).mpFile.AnalogChEnabled[3];
               CopyAnalogDlg.RadioButton2.Enabled := (MDIChildren[0] as TAnalogFrm).mpFile.AnalogChEnabled[3];

               CopyAnalogDlg.SpinEdit1.MaxValue := (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount;
               CopyAnalogDlg.SpinEdit1.Value := 1;
               CopyAnalogDlg.SpinEdit2.MaxValue := (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount;
               CopyAnalogDlg.SpinEdit2.Value := (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount;

               if CopyAnalogDlg.ShowModal = mrOK then
               begin
               	fromFrame := CopyAnalogDlg.SpinEdit1.Value - 1;
                   toFrame := CopyAnalogDlg.SpinEdit2.Value - 1;
                   if 	(fromFrame >= 0) and (fromFrame <= (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount - 1) and
                   	(toFrame >= 0) and (toFrame <= (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount - 1) and
                       (fromFrame <= toFrame) then
                   begin
                   	with SaveDialog1 do
                       begin
                       	DefaultExt := 'TXT';
                           Filter := 'Text Files (*.TXT)|*.TXT|All Files (*.*)|*.*';
                           Title := 'Save Analog Data In Text File';
                       end;

                       if SaveDialog1.Execute then
                       begin
                       	savedCursor := Screen.Cursor;
                           try
                           	Screen.Cursor := crHourGlass;
                               (MDIChildren[0] as TAnalogFrm).mpFile.SaveChannelsToFile(bASCII,
                               	SaveDialog1.Filename,
                                   CopyAnalogDlg.RadioButton1.Checked and CopyAnalogDlg.RadioButton1.Enabled,
                                   CopyAnalogDlg.RadioButton2.Checked and CopyAnalogDlg.RadioButton2.Enabled,
                                   fromFrame, toFrame);
                           finally
                           	Screen.Cursor := savedCursor;
                       	end;
                       end;
                   end
                   else
                   	MessageDlg('Invalid frame indices.', mtError, [mbOK], 0);
               end; {showmodal}
   		end  {frame count > 0}
       	else
           	MessageDlg('Analog Window ' + (MDIChildren[0] as TAnalogFrm).mpFile.Filename +
               ' has no data to save.', mtInformation, [mbOK], 0);
end;


procedure TMainform.AnalogTraceAsMetafile1Click(Sender: TObject);
var	mr: Word;
begin
   if MDIChildCount > 0 then
       if MDIChildren[0] is TAnalogFrm then
       	if (MDIChildren[0] as TAnalogFrm).mpFile.FrameCount > 0 then
           begin
           	SaveDialog1.Title := 'Save Trace as Windows Metafile';
               SaveDialog1.DefaultExt := 'EMF';
               SaveDialog1.Filter := 'Windows Enhanced Metafile (*.EMF)|*.EMF|All Files (*.*)|*.*';

				mr := MessageDlg('Do you want to save Analog Ch 1 trace?', mtInformation, [mbYes,mbNo,mbCancel], 0);
               if mr = mrYes then
               begin
               	if SaveDialog1.Execute then (MDIChildren[0] as TAnalogFrm).SaveTrace(1, SaveDialog1.Filename);
               end
               else if mr = mrNo then
					if MessageDlg('Do you want to save Analog Ch 1 trace?', mtInformation, [mbYes,mbCancel], 0) = mrYes then
               		if SaveDialog1.Execute then (MDIChildren[0] as TAnalogFrm).SaveTrace(2, SaveDialog1.Filename);
           end;
end;


procedure TMainform.About1Click(Sender: TObject);
begin
   AboutDlg.ShowModal;
end;


procedure TMainform.Options1Click(Sender: TObject);
begin
   if not VarIsEmpty(matlab) then Exit;
   if OptDlg.ShowModal = mrOK then
   try
       Screen.Cursor := crHourGlass;
       VariantInit(matlab);
       if bLocalMatlabServer then
       begin
           matlab := CreateOLEObject('Matlab.Application');
           matlab.Visible := 1;
       end
       else
           matlab := CreateRemoteCOMObject(remoteMatlabServer, DIID_DIMLApp);

           mconsole := Tmconsole.Create(self);
           mconsole.Show;
   finally
       Screen.Cursor := crDefault;
   end;
   if VarIsEmpty(matlab) then
       MessageDlg('MPView cannot start Matlab.', mtError, [mbOK], 0);
end;


procedure TMainform.StopMatlab1Click(Sender: TObject);
begin
   if not(VarIsEmpty(matlab)) then
   begin
       VariantClear(matlab);
       VariantInit(matlab);
       mconsole.Close;
       mconsole := nil;
   end;
end;


procedure TMainform.FileInformation1Click(Sender: TObject);
begin
   if ActiveFile <> nil then
   begin
       FileInfoDlg.Fill(ActiveFile as TMPFile);
       FileInfoDlg.ShowModal;
   end;
end;


procedure TMainform.Close1Click(Sender: TObject);
begin
   if ActiveFile <> nil then
       (ActiveFile as TMPFile).Close(self)
   else
   	ActiveMDIChild.Close;
end;


procedure TMainform.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   bAppClosing := True;
end;

procedure TMainform.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TMainform.Tile1Click(Sender: TObject);
begin
	Tile;
end;

procedure TMainform.Cascade1Click(Sender: TObject);
begin
	Cascade;
end;

procedure TMainform.ArrangeAll1Click(Sender: TObject);
begin
	ArrangeIcons;
end;

procedure TMainform.ROIDataAs1Click(Sender: TObject);
var	savedCursor: TCursor;
       bASCII: boolean;
       padding: integer;
begin
   if MDIChildCount > 0 then
       if MDIChildren[0] is TROIFrm then
       	if (MDIChildren[0] as TROIFrm).toFrame - (MDIChildren[0] as TROIFrm).fromFrame > 0 then
           begin
           	bASCII := (MessageDlg('Do you want to save the file as plain ASCII (Yes) or Unicode (No)?',
               	mtInformation, [mbYes, mbNo], 0)= mrYes);
               if MessageDlg('Do you want to add extra data points between ROI values?', mtInformation,
               	[mbYes, mbNo], 0) = mrYes then
               begin
               	try
               		padding := StrToInt(InputBox('Data Points Between ROI Values', 'Enter total data points', '1'));
                   except
                   	padding := 0;
                   end;
               end
               else
               	padding := 1;

               if 	(padding > 0) and (padding < 10000000) then
               begin
               	with SaveDialog1 do
                   begin
                   	DefaultExt := 'TXT';
                       Filter := 'Text Files (*.TXT)|*.TXT|All Files (*.*)|*.*';
                       Title := 'Save ROI Data In Text File';
                   end;

                   if SaveDialog1.Execute then
                   begin
                   	savedCursor := Screen.Cursor;
                       try
                       	Screen.Cursor := crHourGlass;
                           (MDIChildren[0] as TROIFrm).SaveDataToFile(bASCII, padding,
                               	SaveDialog1.Filename);
                       finally
                       	Screen.Cursor := savedCursor;
                       end;
                   end;
               end
               else
               	MessageDlg('Invalid padding value.', mtError, [mbOK], 0);
   		end  {frame count > 0}
       	else
           	MessageDlg('ROI Window ' + MDIChildren[0].Caption +
               ' has no data to save.', mtInformation, [mbOK], 0);
end;

end.
