unit mconsolefrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ActiveX, ComObj;

type
  Tmconsole = class(TForm)
    Memo1: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mconsole: Tmconsole;

implementation

uses mainfrm {, Variants};

{$R *.DFM}

procedure Tmconsole.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	if not Mainform.bAppClosing then
   begin
   	if not(VarIsEmpty(Mainform.matlab)) then
   	begin
       	VariantClear(Mainform.matlab);
       	VariantInit(Mainform.matlab);
       end;
   	Action := caFree;
   end;
end;



procedure Tmconsole.FormShow(Sender: TObject);
begin
	Memo1.Lines.Add('Enter Matlab code after the prompt.');
	Memo1.Text := Memo1.Text + '>';
   Memo1.SelStart := Length(Memo1.Text); {sets before CR}
   Memo1.SelLength := 0;
end;


procedure Tmconsole.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var    v: Variant;
       s, sm: string;
       i: integer;
begin
   if Key = 13 {Line feed} then
   begin
       {look for line containing the last caret}
		s := Memo1.Lines[Memo1.Lines.Count - 1];
		if s[1] = '>' then
       begin
       	{removes '>'}
           sm := Copy(s, 2, Length(s) - 1);
           v := sm; {prepares variant}
           sm := VarToStr(Mainform.matlab.Execute(v));
           {adds a CR before a LF}
           s := '';
           if Length(sm) > 0 then
				for i := 1 to Length(sm) do
               begin
                   if sm[i] = Chr(10) then s := s + Chr(13);
               	s := s + sm[i];
               end;
           Memo1.Lines.Add(s);
       end;
       Memo1.Text := Memo1.Text + '>';
       Memo1.Refresh;
       Memo1.SelStart := Length(Memo1.Text);
       Memo1.SelLength := 0;
   end;
end;

initialization
   mconsole := nil;

end.
