unit motioncorrdlgu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls, Buttons, vieweru;

type
  TMotionCorrectionDlg = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ProgressBar1: TProgressBar;
    Label4: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
    bAbortMotionCorrection,
    bMotionCorrectionStarted: boolean;
    motionViewer: TViewerFrm;
    motionRect: TRect;
    motionCh,
    firstFrame: integer;
  public
    { Public declarations }
    procedure Initialize(aViewer: TViewerFrm; refFrameIndex, refChannel: integer; motionrc: TRect);
  end;

var
  MotionCorrectionDlg: TMotionCorrectionDlg;

implementation

{$R *.DFM}

uses MPViewu;

procedure TMotionCorrectionDlg.Initialize(aViewer: TViewerFrm; refFrameIndex, refChannel: integer; motionrc: TRect);
begin
    motionViewer := aViewer;
    motionCh := refChannel;
    firstFrame := refFrameIndex;
    motionRect :=  motionrc;
end;

procedure TMotionCorrectionDlg.FormShow(Sender: TObject);
begin
	SpinEdit1.MinValue := 1;
	SpinEdit2.MinValue := 1;
	SpinEdit3.MinValue := 1;
	SpinEdit1.MaxValue := motionViewer.mpFile.FrameCount;
	SpinEdit2.MaxValue := motionViewer.mpFile.FrameCount;
	SpinEdit3.MaxValue := motionViewer.mpFile.FrameCount;
   SpinEdit1.Value := firstFrame + 1;
   SpinEdit2.Value := 1;
   SpinEdit3.Value := motionViewer.mpFile.FrameCount;

	SpinEdit1.Enabled := True;
   SpinEdit1.Enabled := True;
   SpinEdit1.Enabled := True;
	BitBtn1.Enabled := True;
   Label4.Visible := False;
   Label4.Refresh;
   ProgressBar1.Position := 0;
end;


procedure TMotionCorrectionDlg.BitBtn1Click(Sender: TObject);
var	blockSize, i, framesIncrement: integer;
begin
	if (SpinEdit1.Value > 0) and (SpinEdit1.Value <= motionViewer.mpFile.FrameCount) and
	   (SpinEdit2.Value > 0) and (SpinEdit2.Value <= motionViewer.mpFile.FrameCount) and
		(SpinEdit3.Value > 0) and (SpinEdit3.Value <= motionViewer.mpFile.FrameCount) and
		(SpinEdit2.Value < SpinEdit3.Value) then
   begin
   	SpinEdit1.Enabled := False;
   	SpinEdit1.Enabled := False;
   	SpinEdit1.Enabled := False;
       BitBtn1.Enabled := False;
       Label4.Visible := True;
       Label4.Refresh;

       try
    		bMotionCorrectionStarted := True;
			blockSize := motionViewer.mpFile.FrameCount div 100; {we'll update every 1%}
           if blockSize = 0 then blockSize := 1;  {or every frame}

           motionViewer.mpFile.PrepareMotionCorrection(SpinEdit1.Value - 1, motionCh, motionRect);

           framesIncrement := 0; i := SpinEdit2.Value - 1;
           repeat
           	motionViewer.mpFile.PerformMotionCorrection(i);
               framesIncrement := framesIncrement + 1;
               if framesIncrement >= blockSize then
               begin
               	framesIncrement := 0;
                   Application.ProcessMessages;
					ProgressBar1.Position := MulDiv(100, i - SpinEdit2.Value + 1,
                   	SpinEdit3.Value - SpinEdit2.Value + 1);
               end;
           	i := i + 1;
           until bAbortMotionCorrection or (i >= SpinEdit3.Value);
           motionViewer.mpFile.FinishMotionCorrection;

       	if not bAbortMotionCorrection then
           begin
   			// Motion correction was OK
           	motionViewer.EnableMotionCorrection1.Checked := True;
               if MessageDlg('Do you want to store the motion corrections permanently?' + CRLF +
               	'(this may depend on file access privileges.)', mtInformation, [mbYes, mbNo], 0) =
                   mrYes then
                   	if motionViewer.mpFile.SaveMotionCorrection then
                       	MessageDlg('Motion correction stored in file.', mtInformation, [mbYes], 0)
                       else
                       	MessageDlg('Unable to store motion correction stored in file.', mtError, [mbYes], 0);
           end;
       except
   		MessageDlg('An error has occurred during motion correction processing.', mtError, [mbOK], 0);
       end;
       ModalResult := mrOK;
   end
   else
   begin
   	MessageDlg('Invalid frame indices.', mtError, [mbOK], 0);
   	ModalResult := mrNone;
   end;
end;

procedure TMotionCorrectionDlg.BitBtn2Click(Sender: TObject);
begin
	if bMotionCorrectionStarted then
   begin
   	bAbortMotionCorrection := True;
       ModalResult := mrNone;
   end
   else
   	ModalResult := mrCancel;
end;

end.
