unit mp_ippiu;

interface

{$ALIGN ON}
{$MINENUMSIZE 4}

uses Windows;

type
	pIPP32f = ^IPP32f;
	IPP32f  = single;
	ippStatus = integer;

var
  m_nLibName: Integer;
  m_nccLibName: Integer;
  m_LibExists: array[0..5] of boolean;
  m_ccLibExists: array[0..5] of boolean;

function InitDLL(flag: String; nThreads: Integer) : integer;
procedure FreeDLL;

implementation

uses SysUtils;

const
	lName = 'Path';
	size: Integer = 256;
	ippcoreDLL = 'ippcore-5.3.dll';
	libsName: array[0..5] of string=(
		'ippipx-5.3.dll','ippia6-5.3.dll','ippiw7-5.3.dll',
		'ippit7-5.3.dll','ippiv8-5.3.dll','ippip8-5.3.dll');
	cclibsName: array[0..5] of string = (
		'ippccpx-5.3.dll','ippcca6-5.3.dll','ippccw7-5.3.dll','ippcct7-5.3.dll',
		'ippccv8-5.3.dll','ippccp8-5.3.dll');

var
	Handle  : HINST;
	ccHandle  : HINST;
	IppiDLL : PChar = 'ippi-5.3.dll';
	IppccDLL : PChar = 'ippcc-5.3.dll';
	buffer: array [0..255] of Char;
	pathDir: string;


function InitDLL(flag: String; nThreads: Integer) : integer;
const
	sThreads = 'OMP_NUM_THREADS';
var
	buf: array[0..1] of Char;
	version: PIppLibraryVersion;
	str: string;
	CpuType: Integer;
begin
	if nThreads > 0 then
	begin
		GetEnvironmentVariable(sThreads, buf, 2);
		buf[0] := IntToStr(nThreads)[1];
		buf[1] := #0;
		SetEnvironmentVariable(sThreads, buf);
	end;
	if flag = '' then
	begin
		Handle := LoadLibrary(IppiDLL);
 		if Handle <> 0 then
		begin
			GetModuleFileName(Handle, @buffer, size);
			pathDir := ExtractFileDir(buffer)+'\';
			@ippiGetLibVersion := GetProcAddress(Handle,'ippiGetLibVersion');
			if ippiGetLibVersion <> nil then
			begin
				version := ippiGetLibVersion;
				str := version.Name;
				FreeLibrary(Handle);
				Handle := LoadLibrary(PChar(pathDir+str));
				if str = libsName[0] then m_nLibName := 0;
				if str = libsName[1] then m_nLibName := 1;
				if str = libsName[2] then m_nLibName := 	
				if str = libsName[3] then m_nLibName := 3;
				if str = libsName[4] then m_nLibName := 4;
				if str = libsName[5] then m_nLibName := 5;		
				CpuType := ippGetCpuType;
				m_LibExists[0] := FileExists(pathDir+libsName[0]);
				m_LibExists[1] := FileExists(pathDir+libsName[1]) and (CpuType>=ippCpuPIII);
				m_LibExists[2] := FileExists(pathDir+libsName[2]) and (CpuType>=ippCpuP4);
				m_LibExists[3] := FileExists(pathDir+libsName[3]) and ((CpuType >= ippCpuP4HT2) or (CpuType >= ippCpuCoreDuo) or (CpuType >=ippCpuCoreSolo) or (CpuType >=ippCpuEM64T));
				m_LibExists[4] := FileExists(pathDir+libsName[4]) and ((CpuType =ippCpuC2D) or (CpuType =ippCpuC2Q));
				m_LibExists[5] := FileExists(pathDir+libsName[5]) and (CpuType = ippCpuSSE41);
      			end;
    		end;
    		ccHandle := LoadLibrary(IppccDLL	
		if ccHandle <> 0 then
		begin
			GetModuleFileName(ccHandle, @buffer, siz		
			pathDir := ExtractFileDir(buffer)+'\';
			@ippccGetLibVersion := GetProcAddress(ccHandle,'ippccGetLibVersion');
			if ippccGetLibVersion <> nil then
			begin
				version := ippccGetLibVersion;
				str := version.Name;
				FreeLibrary(ccHandle);
				ccHandle := LoadLibrary(PChar(pathDir+str))
				if str = cclibsName[0] then m_nccLibName := 0;
				if str = cclibsName[1] then m_nccLibName := 1;
				if str = cclibsName[2] then m_nccLibName := 2;
				if str = cclibsName[3] then m_nccLibName := 3;
				if str = cclibsName[4] then m_nccLibName := 4;
				if str = cclibsName[5] then m_nccLibName := 5;
				CpuType := ippGetCpuType;
				m_ccLibExists[0] := FileExists(pathDir+cclibsName[0]);
				m_ccLibExists[1] := FileExists(pathDir+cclibsName[1]) and (CpuType>=ippCpuPIII);
 				m_ccLibExists[2] := FileExists(pathDir+cclibsName[2]) and (CpuType>=ippCpuP4);
				m_ccLibExists[3] := FileExists(pathDir+cclibsName[3]) and ((CpuType >= ippCpuP4HT2) or (CpuType >= ippCpuCoreDuo) or (CpuType >=ippCpuCoreSolo) or (CpuType >=ippCpuEM64T));
				m_ccLibExists[4] := FileExists(pathDir+cclibsName[4]) and ((CpuType =ippCpuC2D) or (CpuType =ippCpuC2Q));
				m_ccLibExists[5] := FileExists(pathDir+cclibsName[5]) and (CpuType = ippCpuSSE41);
			end;	
		end;
	end
	else
  	begin
    		FreeLibrary(Handle);
		//Handle := LoadLibrary(PChar(pathDir+libsName[flag]));
		Handle := LoadLibrary(PChar(pathDir+flag+'-5.3.dll'));
	end;
	
	if Handle = 0 then
	begin
 		result := -1;
    		Exit;
	end;

	result := 0;
end;


procedure FreeDLL;
begin
	if Handle <> 0 then FreeLibrary(Handle);
	if ccHandle <> 0 then FreeLibrary(ccHandle);
end;


initialization
	InitDLL('', -1);

finalization
	FreeDLL;

end.
