unit vieweru;

interface

uses                                                                    
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, ToolWin, ComCtrls, ExtCtrls, mpviewu, mpfileu;

type
   TMouseAction = (maNormal, maRectangularROI, maEllipticROI, maLineProfile, maStats,
   	maMotionCorrection);

   TViewerFrm = class(TForm)
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    Frame1: TMenuItem;
    NextFrame1: TMenuItem;
    PrevFrame1: TMenuItem;
    N1: TMenuItem;
    FastForward1: TMenuItem;
    FastReverse1: TMenuItem;
    N2: TMenuItem;
    FirstFrame1: TMenuItem;
    LastFrame1: TMenuItem;
    GotoFrame1: TMenuItem;
    ROI1: TMenuItem;
    Zoom1: TMenuItem;
    Increasezoom1: TMenuItem;
    DecreaseZoom1: TMenuItem;
    Grayscale1: TMenuItem;
    FalseColors1: TMenuItem;
    N3: TMenuItem;
    CreateProjection1: TMenuItem;
    CopyFrames1: TMenuItem;
    Stop1: TMenuItem;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    SaveFrameasBitmap1: TMenuItem;
    MakeAVIMovie1: TMenuItem;
    N5: TMenuItem;
    SubtractwithFrame1: TMenuItem;
    N6: TMenuItem;
    Comments1: TMenuItem;
    N7: TMenuItem;
    NewFrameViewer1: TMenuItem;
    CopyFrames2: TMenuItem;
    N8: TMenuItem;
    SaveDialog1: TSaveDialog;
    GammaCorrection1: TMenuItem;
    N9: TMenuItem;
    AverageFrames1: TMenuItem;
    ProjectFrameonYaxis1: TMenuItem;
    ProjectFramesonXaxis1: TMenuItem;
    Objects1: TMenuItem;
    FindObjects1: TMenuItem;
    DeleteallObjects1: TMenuItem;
    PlotROIofObjects1: TMenuItem;
    CreateRectangularROI1: TMenuItem;
    CreateEllipticalROI1: TMenuItem;
    HideROIs1: TMenuItem;
    N4: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    CreateLineProfile1: TMenuItem;
    ToolButton9: TToolButton;
    AutomaticBackgroundCorrection1: TMenuItem;
    AreaStats1: TMenuItem;
    ExportFramesasamultipageTIFFfile1: TMenuItem;
    PaintBox1: TPaintBox;
    CustomColors1: TMenuItem;
    N12: TMenuItem;
    CustomColorsLookupTable1: TMenuItem;
    N13: TMenuItem;
    BinaryFrameOperations1: TMenuItem;
    N14: TMenuItem;
    OverlayCh1onCh21: TMenuItem;
    OverlayCh2onCh31: TMenuItem;
    PerformMotionCorrection1: TMenuItem;
    EnableMotionCorrection1: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure FirstFrame1Click(Sender: TObject);
    procedure LastFrame1Click(Sender: TObject);
    procedure GotoFrame1Click(Sender: TObject);
    procedure Comments1Click(Sender: TObject);
    procedure Grayscale1Click(Sender: TObject);
    procedure Increasezoom1Click(Sender: TObject);
    procedure DecreaseZoom1Click(Sender: TObject);
    procedure NewFrameViewer1Click(Sender: TObject);
    procedure SaveFrameasBitmap1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Gammacorrection1Click(Sender: TObject);
    procedure CopyFrames2Click(Sender: TObject);
    procedure AverageFrames1Click(Sender: TObject);
    procedure CreateProjection1Click(Sender: TObject);
    procedure ProjectFrameonYaxis1Click(Sender: TObject);
    procedure ProjectFramesonXaxis1Click(Sender: TObject);
    procedure SubtractwithFrame1Click(Sender: TObject);
    procedure DeleteallROIs1Click(Sender: TObject);
    procedure MakeAVIMovie1Click(Sender: TObject);
    procedure DeleteallObjects1Click(Sender: TObject);
    procedure HideROIs1Click(Sender: TObject);
    procedure CreateRectangularROI1Click(Sender: TObject);
    procedure CreateEllipticalROI1Click(Sender: TObject);
    procedure FindObjects1Click(Sender: TObject);
    procedure PlotROIofObjects1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDblClick(Sender: TObject);
    procedure CreateLineProfile1Click(Sender: TObject);
    procedure CopyFrames1Click(Sender: TObject);
    procedure AutomaticBackgroundCorrection1Click(Sender: TObject);
    procedure AreaStats1Click(Sender: TObject);
    procedure ExportFramesasamultipageTIFFfile1Click(Sender: TObject);
    procedure CustomColors1Click(Sender: TObject);
    procedure FalseColors1Click(Sender: TObject);
    procedure CustomColorsLookupTable1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure BinaryFrameOperations1Click(Sender: TObject);
    procedure OverlayCh1onCh21Click(Sender: TObject);
    procedure OverlayCh2onCh31Click(Sender: TObject);
    procedure EnableMotionCorrection1Click(Sender: TObject);
    procedure PerformMotionCorrection1Click(Sender: TObject);
  private
    { Private declarations }
    roiPt: TPoint;
    colorScheme: TColorScheme;
    chRect, bitmapChRect: array[0..MAX_CH - 1] of TRect;
    frameBitmap: TBitmap;
    fCurrentFrameIndex: integer;
    fZoomIndex: integer;

    bMotionCorrectionStarted: boolean;
    currentChannel, anchorX, anchorY, prevX, prevY: integer;
    mouseAction: TMouseAction;
    ROIList: TROIList;

    procedure  AdjustWindowSize;
    function	CheckNoFrame: boolean;
    procedure  DrawFrame;
    procedure	GetChRect;
    procedure  ExportToMatlab(chIndex, fromFrame, toFrame: integer;
               frameName: string; startingIndex: integer; workspace: string);
    procedure  MakeColorScale;
    procedure  OnNewFrame;
    procedure  SelectROIPlot(bAllROIs: boolean; roiIndex: integer);
	 procedure  SetLUTColors;
    procedure  PlotLineProfile(chIndex: integer; rc: TRect);
    procedure  PlotROI(roiIndex, fromFrame, toFrame: integer);
    procedure  SetCurrentFrameIndex(newIndex: integer);
	 function   WindowToChannel(X, Y: integer; var retChannel: integer): boolean;
    function   WindowToFrameX(chIndex, xVal: integer): integer;
    function   WindowToFrameY(yVal: integer): integer;
  public
    { Public declarations }
    mpFile: TMPFile;

    procedure  Initialize(thempFile: TMPFile; viewerIndex: integer);

    property   CurrentFrameIndex: integer read fCurrentFrameIndex write SetCurrentFrameIndex;
  end;

var
  ViewerFrm: TViewerFrm;

implementation

{$R *.DFM}

uses Mainfrm, gammafrmu, opframedlgu, DetectROIDlgu, PlotROIDlgu,
       AVIOptDlgu, ROIFrmu, mtransferdlgu, ActiveX, StatDlgu, lutdlgu, binfrm,
       motioncorrdlgu, mp_ippi
       {, Variants};

{-------------------------------- PRIVATE -------------------------------------}

procedure  TViewerFrm.AdjustWindowSize;
var    newWidth, newHeight: integer;
begin
   if mpFile = nil then Exit;
   {just in case width and height suddenly changed as caused by mpFile.StackX or mpFile.StackY}
   newWidth := mpFile.VideoChCount * mpFile.FrameWidth + mpFile.VideoChCount - 1;
   newHeight := mpFile.FrameHeight;
   if (frameBitmap.Width <> newWidth) or (frameBitmap.Height <> newHeight) then
   begin
       frameBitmap.Width := newWidth;
       frameBitmap.Height := newHeight;
   end;

   GetChRect;

   if chRect[MAX_CH - 1].Right - chRect[0].Left + PaintBox1.Width + 1 > 500 then
       ClientWidth := chRect[MAX_CH - 1].Right - chRect[0].Left + PaintBox1.Width + 1
   else
       ClientWidth := 500;

   if Panel1.Height +  StatusBar1.Height + fZoomIndex * mpFile.FrameHeight > 500 then
       ClientHeight := Panel1.Height +  StatusBar1.Height + fZoomIndex * mpFile.FrameHeight
   else
       ClientHeight := 500;
end;



function	TViewerFrm.CheckNoFrame: boolean;
begin
	if (mpFile = nil) or (mpFile.FrameCount = 0) then
   begin
   	Result := True;
       MessageDlg( 'Operation not possible.' + CRLF +
       			'Workspace has no frame.', mtInformation, [mbOK], 0);
   end
   else
   	Result := False;
end;

type	TBitmapLine = array[0..Maxint div 8] of TRGBTriple;
		TpBitmapLine = ^TBitmapLine;

procedure  TViewerFrm.DrawFrame;
var    i, j, k, l, m, pixelValue, pixelXOffset, maxPixValue: integer;
       pLine : TpBitmapLine;
       pixel0, pixel1: TRGBTriple;
const	RGB_GREEN: TRGBTriple = (rgbtBlue: 0; rgbtGreen: 255; rgbtRed: 0);
		RGB_BLACK: TRGBTriple = (rgbtBlue: 0; rgbtGreen: 255; rgbtRed: 0);
begin
   {separation line between channels}
   with mpFile, frameBitmap, frameBitmap.Canvas do
       if VideoChCount > 1 then
       begin
   		Brush.Color := clBlack;
       	FillRect(Rect(0,0,frameBitmap.Width - 1, frameBitmap.Height - 1));
       	Pen.Width := 1;
           if colorScheme = CS_GRAYSCALE then Pen.Color := clOlive else Pen.Color := clRed;
           Pen.Style := psSolid;
           Pen.Mode := pmCopy;
           for i := 1 to VideoChCount - 1 do
           begin
           	MoveTo(i * (FrameWidth + 1) - 1, 0);
               LineTo(i * (FrameWidth + 1) - 1, FrameHeight - 1);
           end;
       end;

   with mpFile do
       for m := 0 to MAX_CH - 1 do
       	if VideoChEnabled[m] then
           begin
           	maxPixValue := ChMaxPixelValues[m];
           	pixelXOffset := bitmapChRect[m].Left;
           	for i := 0 to FrameHeight - 1 do
               begin
           		pLine := frameBitmap.ScanLine[i];
               	for j := 0 to FrameWidth - 1 do
                   begin
                   	k := j + i * FrameWidth; {index in frame data buffer for Ch1}
                       l := j + pixelXOffset;
                   	pixelValue := Frames[CurrentFrameIndex].Channels[m].data[k];

                       {Maps pixel value to 0..MAX_FALSE_COLORS - 1}
                       pixelValue := Muldiv(pixelValue, MAX_FALSE_COLORS - 1, MaxPixValue);

                       if pixelValue < 0 then pixelValue := 0;
                   	if pixelValue > MAX_FALSE_COLORS - 1 then pixelValue := MAX_FALSE_COLORS - 1;

                   	if colorScheme = CS_FALSECOLORS then
                           pLine^[l] := Mainform.falseColorTable[pixelValue]
                   	else if colorScheme = CS_GRAYSCALE then
                           pLine^[l] := Mainform.grayScaleTable[pixelValue]
                       else
                       	pLine^[l] := CustomColors[m][pixelValue];

						{Overlay Ch1 on Ch2}
						if OverlayCh1onCh21.Checked and (m = 1) and (VideoChEnabled[0]) then
                       begin
                       	pixel1 := pLine^[l];
                           pixel0 := pLine^[l - pixelXOffset];
                           pixel1.rgbtBlue := pixel1.rgbtBlue or pixel0.rgbtBlue;
                           pixel1.rgbtGreen := pixel1.rgbtGreen or pixel0.rgbtGreen;
                           pixel1.rgbtRed := pixel1.rgbtRed or pixel0.rgbtRed;
                       	pLine^[l] := pixel1;
                       end;

						{Overlay Ch2 on Ch3}
						if OverlayCh2onCh31.Checked and (m = 2) and (VideoChEnabled[1]) then
                       begin
                       	pixel1 := pLine^[l];
                           pixel0 := pLine^[l - pixelXOffset];
                           pixel1.rgbtBlue := pixel1.rgbtBlue or pixel0.rgbtBlue;
                           pixel1.rgbtGreen := pixel1.rgbtGreen or pixel0.rgbtGreen;
                           pixel1.rgbtRed := pixel1.rgbtRed or pixel0.rgbtRed;
                       	pLine^[l] := pixel1;
                       end;
                   end; {for j}
               end; {for i}
           end; {end VideoChEnabled[m]}

   	if not HideROIs1.Checked then
       	if ROIList.Count > 0 then
           	for i := 0 to ROIList.Count - 1 do
               	with ROIList.ROIs[i] do
               		Draw(frameBitmap, bitmapChRect[Channel].Left);

   	Canvas.CopyRect(Rect(chRect[0].Left, chRect[0].Top, chRect[MAX_CH-1].Right, chRect[MAX_CH - 1].Bottom),
       	frameBitmap.Canvas, Rect(0, 0, frameBitmap.Width - 1, frameBitmap.Height - 1));
end;


type
   TVT8Array = array[0..Maxint div 16] of double;
   TpVT8Array = ^TVT8Array;

procedure  TViewerFrm.ExportToMatlab(chIndex, fromFrame, toFrame: integer;
               frameName: string; startingIndex: integer; workspace: string);
var    i, j, k, l: integer;
       fullFrameName: string;
       pArray: TpVT8Array;
       frameArray, imaginaryArray: Variant;
begin
   try
       Screen.Cursor := crHourGlass;
       if VarIsEmpty(Mainform.matlab) then MainForm.Options1Click(nil);
       if not VarIsEmpty(Mainform.matlab) then
       begin
           frameArray := VarArrayCreate([0, mpFile.FrameHeight - 1, 0, mpFile.FrameWidth - 1],
               varDouble);
           imaginaryArray := Unassigned;
           TVarData(imaginaryArray).VType := varDouble or varArray;
           TVarData(imaginaryArray).VArray := nil;
           for i := fromFrame to toFrame do
           begin
               if fromFrame = toFrame then
                   fullFrameName := frameName
               else
                   fullFrameName := frameName + '_' + IntToStr(startingIndex + i - fromFrame);
               pArray := VarArrayLock(frameArray);
               for j := 0 to mpFile.FrameHeight - 1 do
                   for k := 0 to mpFile.FrameWidth - 1 do
                   begin
                       l := k + j * mpFile.FrameWidth;
                       pArray^[l] := mpFile.Frames[i].Channels[chIndex].data[l];
                   end;
               VarArrayUnlock(frameArray);
               Mainform.matlab.PutFullMatrix(fullFrameName, workspace,
                   VarArrayRef(frameArray), VarArrayRef(imaginaryArray));
           end;
       end;
   finally
       Screen.Cursor := crDefault;
   end;
end;


procedure TViewerFrm.GetChRect;
var	l, r, t, b, zl,zr, zt, zb, curCh, i: integer;
begin
   with mpFile do
   begin
       l := 0;
       r := 0;
       t := 0;
       b := FrameHeight - 1;

       zl := 0;
       zr := zl;
       zt := Panel1.Height + 1;
       zb := zt + fzoomIndex * FrameHeight - 1;

       curCh := 0;

		for i := 0 to MAX_CH - 1 do
       begin
       	if VideoChEnabled[i] then
       	begin
       		{Let's have a border of 1 pixel * zoom if there more than two channels}
       		if (curCh > 0) then
               begin
               	l := r + 2 {border};
                   zl := zr + 1 + fzoomIndex;
               end;
       		r := l + FrameWidth - 1;
       		zr := zl + fzoomIndex * FrameWidth - 1;
       		curCh := curCh + 1;
       	end;
       	bitmapChRect[i] := Rect(l, t, r, b);
       	chRect[i] := Rect(zl, zt, zr, zb);
       end;
   end;
end;


procedure TViewerFrm.MakeColorScale;
var    firstX, lastX, firstY, lastY, i, j, validCh,
		beginstripe, endstripe: integer;
       curColor: TColor;
       rgbTriple: TRGBTriple;
begin
   with PaintBox1, PaintBox1.Canvas do
   begin
       Brush.Color := clBlack;
       FillRect(ClientRect);
       firstX := ClientRect.Left + 2;
       lastX :=  ClientRect.Right - 2;
       firstY :=  ClientRect.Top + 2;
       lastY :=  ClientRect.Bottom - 2;
       if GrayScale1.Checked then
           for i := firstY to LastY do
           begin
               curColor := Muldiv(255, i - LastY, firstY - LastY);
               if i = firstY then Pen.Color := RGB(255, 0, 0) else
               if i = (lastY - firstY) div 2 + firstY then Pen.Color := RGB(0, 0, 255) else
                   Pen.Color := RGB(curColor, curColor, curColor);
               MoveTo(firstX, i);
               LineTo(lastX, i);
           end
       else if FalseColors1.Checked then
           for i := firstY to LastY do
           begin
               rgbTriple := Mainform.falseColorTable[Muldiv(MAX_FALSE_COLORS -1, i - LastY, firstY - LastY)];
               Pen.Color := RGB(rgbTriple.rgbtRed, rgbTriple.rgbtGreen, rgbTriple.rgbtBlue);
               MoveTo(firstX, i);
               LineTo(lastX, i);
           end
       else {custom LUT}
       	with mpFile do
           	begin
               	validCh := 0;
           		for j := 0 to MAX_CH - 1 do
               		if VideoChEnabled[j] then
                       begin
                       	beginstripe := firstX + Muldiv(validCh, lastX - firstX, VideoChCount);
                           endstripe := firstX + Muldiv(validCh + 1, lastX - firstX, VideoChCount);
           				for i := firstY to LastY do
							begin
               				rgbTriple := CustomColors[j,
                               	Muldiv(MAX_FALSE_COLORS - 1, i - LastY, firstY - LastY)];
               				Pen.Color := RGB(rgbTriple.rgbtRed, rgbTriple.rgbtGreen, rgbTriple.rgbtBlue);
               				MoveTo(beginstripe, i);
               				LineTo(endstripe, i);
                           end;
                       	validCh := validCh + 1;
                       end;
               end;
   end; {with begin}
end;


procedure  TViewerFrm.OnNewFrame;
begin
   AdjustWindowSize;
   if AutomaticBackgroundCorrection1.Checked then mpFile.DoBackgroundCorrection;
   DrawFrame;

   StatusBar1.Panels[0].Text := 'Frame ' + IntToStr(CurrentFrameIndex + 1) + '/'
       + IntToStr(mpFile.FrameCount);
   StatusBar1.Panels[6].Text := mpFile.FrameComment[CurrentFrameIndex];
end;


procedure  TViewerFrm.SelectROIPlot(bAllROIs: boolean; roiIndex: integer);
var    i, fromFrame, toFrame: integer;
begin
   if ROIList.Count > 0 then
   begin
       with PlotROIDlg do
       begin
           ComboBox1.Clear;
           for i := 0 to ROIList.Count - 1 do
               ComboBox1.Items.Add(IntToStr(i + 1));
           if bAllROIs then
           begin
               ComboBox1.Enabled := True;
               ComboBox1.ItemIndex := 0;
           end
           else
           begin
               ComboBox1.ItemIndex := roiIndex;
               ComboBox1.Enabled := False;
           end;
           SpinEdit1.MinValue := 1;
           SpinEdit1.MaxValue := mpFile.FrameCount;
           SpinEdit1.Value := 1;
           SpinEdit2.MinValue := mpFile.FrameCount;
           SpinEdit2.MaxValue := mpFile.FrameCount;
           SpinEdit2.Value := mpFile.FrameCount;
           if PlotROIDlg.ShowModal = mrOK then
           begin
               fromFrame := SpinEdit1.Value - 1;
               toFrame := SpinEdit2.Value - 1;
               if (fromFrame >= 0) and (fromFrame < mpFile.FrameCount) and
                   (toFrame >= 0) and (toFrame < mpFile.FrameCount) and
                   (toFrame >= fromFrame) then
                   begin
                   	if (fromFrame <> toFrame) then
                       	PlotROI(ComboBox1.ItemIndex, fromFrame, toFrame)
                       else
                       	MessageDlg('Average ROI value = ' +
                           	IntToStr(mpFile.GetROIAverageValue(ROIList, ComboBox1.ItemIndex, toFrame)),
                               mtInformation, [mbOK], 0);
                   end
               else
                   MessageDlg('Invalid parameters', mtError, [mbOK], 0);
           end;
       end;
   end;
end;


procedure  TViewerFrm.PlotROI(roiIndex, fromFrame, toFrame: integer);
var    aROIFrm: TROIFrm;
       i: integer;
begin
   try
       Screen.Cursor := crHourGlass;
       aROIFrm := TROIFrm.Create(Mainform);
       aROIFrm.FrameRate := mpFile.FrameRate;
       aROIFrm.FromFrame := fromFrame;
       aROIFrm.ToFrame := toFrame;
       aROIFrm.dataSize := toFrame - fromFrame + 1;
       aROIFrm.Caption := Caption + '- ROI: ' + IntToStr(roiIndex + 1);
       for i := fromFrame to toFrame do
           aROIFrm.dataBuffer[i - fromFrame] := mpFile.GetROIAverageValue(ROIList, roiIndex, i);
       aROIFrm.Show;
       aROIFrm.FormResize(nil); {forces repainting}
   finally
       Screen.Cursor := crDefault;
   end;
end;


procedure  TViewerFrm.PlotLineProfile(chIndex: integer; rc: TRect);
var    aROIFrm: TROIFrm;
       i, j, x, y: integer;
       bPlotX: boolean;
       firstPt, lastPt: integer;
begin
   bPlotX := (Abs(rc.Right - rc.Left) >= Abs(rc.Bottom - rc.Top));
   if (bPlotX and (rc.Left > rc.Right)) or (not bPlotX and (rc.Top > rc.Bottom)) then
   begin
       i := rc.Top;
       rc.Top := rc.Bottom;
       rc.Bottom := i;
       i := rc.Left;
       rc.Left := rc.Right;
       rc.Right := i;
   end;
   if (Abs(rc.Right - rc.Left) < 10) and (Abs(rc.Bottom - rc.Top) < 10) then
       MessageDlg('Too few points for a profile', mtError, [mbOK], 0)
   else
   begin
       if bPlotX then
       begin
           firstPt := rc.Left;
           lastPt := rc.Right;
       end
       else
       begin
           firstPt := rc.Top;
           lastPt := rc.Bottom;
       end;
       aROIFrm := TROIFrm.Create(Mainform);
       aROIFrm.bLineProfile := True; {turns off automatic X- axis caption}

       aROIFrm.FromFrame := firstPt;
       aROIFrm.ToFrame := lastPt;
       aROIFrm.dataSize := lastPt - firstPt + 1;
       aROIFrm.Caption := Caption + '- Line Profile: ' +
           '(' + IntToStr(rc.Left) + ', ' + IntToStr(rc.Top) + ') to ('  +
                 IntToStr(rc.Right) +', ' + IntToStr(rc.Bottom) + ')';
       for i := firstPt to lastPt do
       begin
           if bPlotX then
           begin
               x := i;
               y := rc.Top + Muldiv(i - firstPt, rc.Bottom - rc.Top, lastPt - firstPt);
           end
           else
           begin
               y := i;
               x := rc.Left + Muldiv(i - firstPt, rc.Right - rc.Left, lastPt - firstPt);
           end;

           j := x + y * mpFile.FrameWidth;
           aROIFrm.dataBuffer[i - firstPt] :=
               mpFile.Frames[CurrentFrameIndex].Channels[chIndex].data[j];
       end;
       aROIFrm.Show;
       aROIFrm.FormResize(nil); {forces repainting}
   end;
end;


procedure  TViewerFrm.SetCurrentFrameIndex(newIndex: integer);
begin
   if (newIndex < 0) or (newIndex >= mpFile.FrameCount) then Exit;
   fCurrentFrameIndex := newIndex;
   mpFile.ActiveFrameIndex := fCurrentFrameIndex;
   OnNewFrame;
end;


procedure TViewerFrm.SetLUTColors;
var    i, j, rval, gval, bval: integer;
begin
	with mpFile do
	for j := 0 to MAX_CH - 1 do
   begin
   	if baseColors[j, 0] then rval := 255 else rval := 0;
   	if baseColors[j, 1] then gval := 255 else gval := 0;
   	if baseColors[j, 2] then bval := 255 else bval := 0;

   	for i := 0 to MaxPixels[j] - 1 do
   	begin
       	CustomColors[j, i].rgbtBlue := Muldiv(bval, i, MaxPixels[j] - 1);
       	CustomColors[j, i].rgbtGreen := Muldiv(gval, i, MaxPixels[j] - 1);
       	CustomColors[j, i].rgbtRed := Muldiv(rval, i, MaxPixels[j] - 1);
   	end;
   	CustomColors[j, 1023] := midRangeColors[j];

       for i := MaxPixels[j] to MAX_FALSE_COLORS -  1 do
   		CustomColors[j, i] := maxColors[j];
   end;
end;



function  TViewerFrm.WindowToChannel(X, Y: integer; var retChannel: integer): boolean;
begin
   Result := True;
   with mpFile do
   if PointStrictlyInRect(Point(X, Y), ChRect[0]) and VideoChEnabled[0] then
       retChannel := 0
   else if PointStrictlyInRect(Point(X, Y), ChRect[1]) and VideoChEnabled[1] then
       retChannel := 1
   else if PointStrictlyInRect(Point(X, Y), ChRect[2]) and VideoChEnabled[2] then
       retChannel := 2
   else if PointStrictlyInRect(Point(X, Y), ChRect[3]) and VideoChEnabled[3] then
       retChannel := 3
   else
       Result := False;
end;


function   TViewerFrm.WindowToFrameX(chIndex, xVal: integer): integer;
begin
   Result := (xVal - chRect[chIndex].Left) div fZoomIndex;
end;


function   TViewerFrm.WindowToFrameY(yVal: integer): integer;
begin
   Result := (yVal - chRect[0].Top) div fZoomIndex;
end;

{--------------------------------- PUBLIC -------------------------------------}

procedure TViewerFrm.Initialize(thempFile: TMPFile; viewerIndex: integer);
begin
   mpFile := thempFile;
   SetLUTColors;
	case mpFile.ColorScheme of
   	CS_GRAYSCALE: GrayScale1.Checked := True;
       CS_FALSECOLORS: FalseColors1.Checked := True;
       CS_CUSTOMLUT: CustomColors1.Checked := True;
   end;
   frameBitmap.Width := mpFile.VideoChCount * mpFile.FrameWidth + mpFile.VideoChCount - 1;
   frameBitmap.Height := mpFile.FrameHeight;
   fZoomIndex := 1;
   fCurrentFrameIndex := 0;
   Caption := ExtractFileName(mpFile.Filename) + ' <- Viewer ' + IntToStr(viewerIndex);
   AdjustWindowSize;
	with mpfile do
		OverlayCh2onCh31.Enabled :=
       	ChEnabled[1] and ChEnabled[2] and VideoChEnabled[2];
   PerformMotionCorrection1.Enabled := (not mpFile.IsMemoryFile) and
   	((mpFile.ScanMode = SM_MOVIE) or (mpFile.ScanMode = SM_REGIONSCAN))
       and (m_IPP_Loaded = 0) {Intel libraries loaded OK};
   EnableMotionCorrection1.Enabled := PerformMotionCorrection1.Enabled and (m_IPP_Loaded = 0);
   EnableMotionCorrection1.Checked := mpFile.MotionCorrectionEnabled;
end;


{-------------------- CONSTRUCTION - DESTRUCTION ------------------------------}

procedure TViewerFrm.FormCreate(Sender: TObject);
begin
   frameBitmap := TBitmap.Create;
   frameBitmap.HandleType := bmDIB;
   frameBitmap.PixelFormat := pf24bit;
   ROIList := TROIList.Create;
   PrevFrame1.ShortCut := ShortCut(VK_LEFT, []);
   NextFrame1.ShortCut := ShortCut(VK_RIGHT, []);
end;


procedure TViewerFrm.FormActivate(Sender: TObject);
begin
   with Mainform do
   begin
       NewFile1.Enabled := True;
       OpenFile1.Enabled := True;
       if mpFile <> nil then
           FileAs1.Enabled := mpFile.IsMemoryFile
       else
           FileAs1.Enabled := False;
       FileInformation1.Enabled := True;
       Close1.Enabled := True;

   end;
end;


procedure TViewerFrm.FormDeactivate(Sender: TObject);
begin
   with Mainform do
   begin
       NewFile1.Enabled := False;
       OpenFile1.Enabled := False;
       FileAs1.Enabled := False;
       FileInformation1.Enabled := False;
       Close1.Enabled := False;
   end;
end;


procedure TViewerFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   action := caFree;
   FreeAndNil(frameBitmap);

   if (mpFile <> nil) and (not Mainform.bAppClosing) then mpFile.OnWndClose(self);
   mpFile := nil;
end;


procedure TViewerFrm.FormDestroy(Sender: TObject);
begin
 {  frameBitmap.Free;}
   ROIList.Free;
end;

{---------------------------------- EVENTS ------------------------------------}


procedure TViewerFrm.ToolButton2Click(Sender: TObject);
begin
   CurrentFrameIndex := CurrentFrameIndex - 1;
end;


procedure TViewerFrm.ToolButton4Click(Sender: TObject);
begin
   CurrentFrameIndex := CurrentFrameIndex + 1;
end;


procedure TViewerFrm.ToolButton3Click(Sender: TObject);
begin
   ToolButton1.Down := False;
   ToolButton5.Down := False;
end;


procedure TViewerFrm.ToolButton1Click(Sender: TObject);
begin
   while (CurrentFrameIndex > 0) and (ToolButton1.Down) do
   begin
       CurrentFrameIndex := CurrentFrameIndex - 1;
       Application.ProcessMessages;
   end;
   ToolButton1.Down := False;
end;


procedure TViewerFrm.ToolButton5Click(Sender: TObject);
begin
   while (CurrentFrameIndex < mpFile.FrameCount - 1) and (ToolButton5.Down) do
   begin
       CurrentFrameIndex := CurrentFrameIndex + 1;
       Application.ProcessMessages;
   end;
   ToolButton5.Down := False;
end;


procedure TViewerFrm.FirstFrame1Click(Sender: TObject);
begin
   CurrentFrameIndex := 0;
end;


procedure TViewerFrm.LastFrame1Click(Sender: TObject);
begin
   CurrentFrameIndex := mpFile.FrameCount - 1;
end;


procedure TViewerFrm.GotoFrame1Click(Sender: TObject);
var    sFrameIndex: string;
       iFrameIndex: integer;
begin
   if (mpFile = nil) or (mpFile.FrameCount = 0) then Exit;
   sFrameIndex := '1';
   if InputQuery('Go to Frame', 'Enter Frame Index', sFrameIndex) then
   begin
       iFrameIndex := StrToInt(sFrameIndex);
       if (iFrameIndex < 1) or (iFrameIndex > mpFile.FrameCount) then
           MessageDlg('Invalid Frame Index.', mtError, [mbOK], 0)
       else
           CurrentFrameIndex := iFrameIndex - 1;
   end;
end;


procedure TViewerFrm.Comments1Click(Sender: TObject);
var    sFrameComment: string;
begin
   if (mpFile = nil) or (mpFile.FrameCount = 0) then Exit;
   sFrameComment := mpFile.FrameComment[CurrentFrameIndex];
   if InputQuery('Frame Comment', 'Enter Frame Comment', sFrameComment) then
   begin
       mpFile.FrameComment[CurrentFrameIndex] := sFrameComment;
       StatusBar1.Panels[6].Text := sFrameComment;
   end;
end;

procedure TViewerFrm.Grayscale1Click(Sender: TObject);
begin
	if Grayscale1.Checked then Exit;
	Grayscale1.Checked := True;
	colorScheme := CS_GRAYSCALE;
   FalseColors1.Checked := False;
   CustomColors1.Checked := False;
   MakeColorScale;
   DrawFrame;
end;


procedure TViewerFrm.Increasezoom1Click(Sender: TObject);
begin
   if fZoomIndex < 5 then
   begin
       fZoomIndex := fZoomIndex + 1;
       AdjustWindowSize;
       DrawFrame;
   end;
end;


procedure TViewerFrm.DecreaseZoom1Click(Sender: TObject);
begin
   if fZoomIndex > 1 then
   begin
       fZoomIndex := fZoomIndex - 1;
       AdjustWindowSize;
       DrawFrame;
   end;
end;


procedure TViewerFrm.NewFrameViewer1Click(Sender: TObject);
begin
   mpFile.NewViewer;
end;


procedure TViewerFrm.SaveFrameasBitmap1Click(Sender: TObject);
begin
   if CheckNoFrame then Exit;
   with SaveDialog1 do
   begin
       DefaultExt := 'BMP';
       Filter := 'Bitmaps (*.BMP)|*.BMP|All Files (*.*)|*.*';
       InitialDir := ExtractFilePath(mpFile.Filename);
       Title := 'Save Frame as Bitmap';
       if Execute then frameBitmap.SaveToFile(Filename);
   end;
end;


procedure TViewerFrm.FormPaint(Sender: TObject);
begin
	if frameBitmap = nil then Exit;

   with Canvas do
   begin
       Brush.Color := clOlive;
       FillRect(ClientRect);
   end;

   Canvas.CopyRect(Rect(chRect[0].Left, chRect[0].Top, chRect[MAX_CH - 1].Right, chRect[MAX_CH - 1].Bottom),
       frameBitmap.Canvas, Rect(0, 0, frameBitmap.Width - 1, frameBitmap.Height - 1));
end;


procedure TViewerFrm.Gammacorrection1Click(Sender: TObject);
var    blackLevel, whiteLevel, i, chIndex: integer;
begin
	if CheckNoFrame then Exit;
   mpFile.ActiveFrameIndex := CurrentFrameIndex;
   GammaFrm.bInitializing := True;
   GammaFrm.mpFile := mpFile;
   GammaFrm.InitGUI(mpFile);
   GammaFrm.CheckBox1.Checked := False;
   GammaFrm.CheckBox1.Enabled := mpFile.IsMemoryFile;
   GammaFrm.TrackBar1.Position := 128; {default black level = 0}
   GammaFrm.TrackBar2.Position := 2047 + 128; {default black level = 0}
   GammaFrm.Label1.Caption := 'Black Level = 0';
   GammaFrm.Label2.Caption := 'White Level = 2047';
   GammaFrm.bInitializing := False;
   if GammaFrm.ShowModal = mrOK then
   begin
       blackLevel := GammaFrm.TrackBar1.Position - 128;
       whiteLevel := GammaFrm.TrackBar2.Position - 128;
       if blackLevel >= whiteLevel then
           MessageDlg('Black Level must be smaller than White Level.', mtError,
               [mbOK], 0)
       else
       begin
			chIndex := GammaFrm.SelectedCh;
           if whiteLevel > mpFile.ChMaxPixelValues[chIndex] then
           begin
           	MessageDlg('Adjusted White Level to maximal possible pixel value.',
               	mtWarning, [mbOK], 0);
				whiteLevel := mpFile.ChMaxPixelValues[chIndex];
           end;
           if GammaFrm.CheckBox1.Checked then
               for i := 0 to mpFile.FrameCount - 1 do
                   (mpFile.Frames[i].channels[chIndex] as TVideoFrame).
                       GammaCorrection(blackLevel, whiteLevel)
           else
               (mpFile.Frames[CurrentFrameIndex].channels[chIndex] as TVideoFrame).
                       GammaCorrection(blackLevel, whiteLevel);
           OnNewFrame;
       end;
   end;
end;


procedure TViewerFrm.AverageFrames1Click(Sender: TObject);
var    fromFrame, toFrame, repeatCount, lastFrame, chIndex, i: integer;
		oldCursor: TCursor;
       destMPFile: TMPFile;
begin
   if CheckNoFrame then Exit;
       if Mainform.fileList.WorkspaceCount = 0 then
           MessageDlg('No workspace for this operation.' + CRLF +
                       'Create a workspace file first.', mtInformation, [mbOK], 0)
           else
           begin
               with opframedlg do
               begin
                   Caption := 'Average Frames';
					opframedlg.InitGUI(mpFile);
                   Mainform.fileList.
                       FillComboBoxWithWorkspaces(ComboBox1);
                   ComboBox1.ItemIndex := 0;
                   Label1.Caption := 'From Frame';
                   Label3.Caption := 'To Frame';
                   SpinEdit1.MinValue := 1;
                   SpinEdit2.MinValue := 1;
                   SpinEdit1.MaxValue := mpFile.FrameCount;
                   SpinEdit2.MaxValue := mpFile.FrameCount;
                   SpinEdit1.Value := CurrentFrameIndex + 1;
                   SpinEdit2.Value := CurrentFrameIndex + 1;

                   Label4.Visible := True;
                   Label4.Caption := 'Repeat';
                   SpinEdit3.MinValue := 1;
                   SpinEdit3.MaxValue := mpFile.FrameCount;
                   SpinEdit3.Value := 1;
                   SpinEdit3.Visible := True;

                   Label5.Visible := False;
                   SpinEdit4.Visible := False;
               end;

               if opframedlg.ShowModal = mrOK then
               begin
                   fromFrame := opframedlg.SpinEdit1.Value - 1;
                   toFrame := opframedlg.SpinEdit2.Value - 1;
                   repeatCount := opframedlg.SpinEdit3.Value;

                   chIndex := opframedlg.SelectedCh;
                   if (fromFrame <= toFrame) and (fromFrame >= 0) and (fromFrame
                       < mpFile.FrameCount) and (toFrame >= 0) and (toFrame <
                       mpFile.FrameCount) then
                   begin
                       lastFrame := fromFrame + (toFrame - fromFrame + 1) * repeatCount
                           - 1;
                       if lastFrame >= mpFile.FrameCount then
                           MessageDlg('Too many repeats.', mtError, [mbOK], 0) else
                       begin
                       	destMPFile := TMPFile(opframedlg.ComboBox1.Items.
                                       Objects[opframedlg.ComboBox1.ItemIndex]);
                       	if destMPFile.SizeOfFrameCompatible(mpFile.FrameWidth, mpFile.FrameHeight) then
                           begin
								oldCursor := Screen.Cursor;
                       		try
                           		Screen.Cursor := crHourGlass;
                           		for i := 0 to repeatCount - 1 do
                               		mpFile.AverageFrames(chIndex,
                                   	fromFrame + i * (toFrame- fromFrame + 1),
                                   	toFrame + i * (toFrame- fromFrame + 1),
                                   	destMPFile);
                           		destMPFile.OnNewFrames;
                       		finally
                           		Screen.Cursor := oldCursor;
                       		end;
                           end;
                       end;
                   end
                   else
                       MessageDlg('Invalid Average Frames parameters', mtError,
                           [mbOK], 0);
               end;
           end;
end;


procedure TViewerFrm.CopyFrames2Click(Sender: TObject);
var    fromFrame, toFrame, chIndex: integer;
		oldCursor: TCursor;
       destMPFile: TMPFile;
begin
   if CheckNoFrame then Exit;
       if Mainform.fileList.WorkspaceCount = 0 then
           MessageDlg('No workspace for this operation.' + CRLF +
                       'Create a workspace file first.', mtInformation, [mbOK], 0)
           else
           begin
               with opframedlg do
               begin
                   Caption := 'Copy Frames';
					opframedlg.InitGUI(mpFile);
                   Mainform.fileList.
                       FillComboBoxWithWorkspaces(ComboBox1);
                   ComboBox1.ItemIndex := 0;
                   Label1.Caption := 'From Frame';
                   Label3.Caption := 'To Frame';
                   SpinEdit1.MinValue := 1;
                   SpinEdit2.MinValue := 1;
                   SpinEdit1.MaxValue := mpFile.FrameCount;
                   SpinEdit2.MaxValue := mpFile.FrameCount;
                   SpinEdit1.Value := CurrentFrameIndex + 1;
                   SpinEdit2.Value := CurrentFrameIndex + 1;

                   Label4.Visible := False;
                   SpinEdit3.Visible := False;
                   Label5.Visible := False;
                   SpinEdit4.Visible := False;
               end;

               if opframedlg.ShowModal = mrOK then
               begin
                   fromFrame := opframedlg.SpinEdit1.Value - 1;
                   toFrame := opframedlg.SpinEdit2.Value - 1;
                   chIndex := opframedlg.SelectedCh;
                   if (fromFrame <= toFrame) and (fromFrame >= 0) and (fromFrame
                       < mpFile.FrameCount) and (toFrame >= 0) and (toFrame <
                       mpFile.FrameCount) then
                       begin
                       	destMPFile := TMPFile(opframedlg.ComboBox1.Items.
                               Objects[opframedlg.ComboBox1.ItemIndex]);
                           if destMPFile.SizeOfFrameCompatible(mpFile.FrameWidth, mpFile.FrameHeight) then
                           begin
                       		oldCursor := Screen.Cursor;
								try
                           		Screen.Cursor := crHourGlass;
                       			mpFile.CopyFrames(chIndex, fromFrame, toFrame,
                           			destMPFile);
                       			destMPFile.OnNewFrames;
                       		finally
                       			Screen.Cursor := oldCursor;
                   			end;
                           end;
                       end
                   else
                       MessageDlg('Invalid Copy Frames parameters', mtError,
                           [mbOK], 0);
               end;
           end;
end;

{Z axis projection}
procedure TViewerFrm.CreateProjection1Click(Sender: TObject);
var    fromFrame, toFrame, chIndex: integer;
		oldCursor: TCursor;
       destMPFile: TMPFile;
begin
   if CheckNoFrame then Exit;
       if Mainform.fileList.WorkspaceCount = 0 then
           MessageDlg('No workspace for this operation.' + CRLF +
                       'Create a workspace file first.', mtInformation, [mbOK], 0)
           else
           begin
               with opframedlg do
               begin
                   Caption := 'Project Frames on Z axis';
					opframedlg.InitGUI(mpFile);
                   Mainform.
                       fileList.FillComboBoxWithWorkspaces(ComboBox1);
                   ComboBox1.ItemIndex := 0;
                   Label1.Caption := 'From Frame';
                   Label3.Caption := 'To Frame';
                   SpinEdit1.MinValue := 1;
                   SpinEdit2.MinValue := 1;
                   SpinEdit1.MaxValue := mpFile.FrameCount;
                   SpinEdit2.MaxValue := mpFile.FrameCount;
                   SpinEdit1.Value := CurrentFrameIndex + 1;
                   SpinEdit2.Value := CurrentFrameIndex + 1;

                   Label4.Visible := False;
                   SpinEdit3.Visible := False;
                   Label5.Visible := False;
                   SpinEdit4.Visible := False;
               end;

               if opframedlg.ShowModal = mrOK then
               begin
                   fromFrame := opframedlg.SpinEdit1.Value - 1;
                   toFrame := opframedlg.SpinEdit2.Value - 1;
                   chIndex := opframedlg.SelectedCh;
                   if (fromFrame <= toFrame) and (fromFrame >= 0) and (fromFrame
                       < mpFile.FrameCount) and (toFrame >= 0) and (toFrame <
                       mpFile.FrameCount) then
                       begin
                       	destMPFile := TMPFile(opframedlg.ComboBox1.Items.
                               	Objects[opframedlg.ComboBox1.ItemIndex]);
                           if destMPFile.SizeOfFrameCompatible(mpFile.FrameWidth, mpFile.FrameHeight) then
                           begin
                           	oldCursor := Screen.Cursor;
                       		try
                           		Screen.Cursor := crHourGlass;
                       			mpFile.StackZ(chIndex, fromFrame, toFrame,
                           			destMPFile);
                       		finally
                           		Screen.Cursor := oldCursor;
                       		end;
                           end;
                       end
                   else
                       MessageDlg('Invalid Projection Frames parameters', mtError,
                           [mbOK], 0);
               end;
           end;
end;


procedure TViewerFrm.ProjectFrameonYaxis1Click(Sender: TObject);
var    fromFrame, toFrame, chIndex, fromX, toX: integer;
		oldCursor: TCursor;
       destMPFile: TMPFile;
begin
   if CheckNoFrame then Exit;
       if Mainform.fileList.WorkspaceCount = 0 then
           MessageDlg('No workspace for this operation.' + CRLF +
                       'Create a workspace file first.', mtInformation, [mbOK], 0)
           else
           begin
               with opframedlg do
               begin
                   Caption := 'Project Frames on Y axis';
					opframedlg.InitGUI(mpFile);
                   Mainform.fileList.
                       FillComboBoxWithWorkspaces(ComboBox1);
                   ComboBox1.ItemIndex := 0;
                   Label1.Caption := 'From Frame';
                   Label3.Caption := 'To Frame';
                   SpinEdit1.MinValue := 1;
                   SpinEdit2.MinValue := 1;
                   SpinEdit1.MaxValue := mpFile.FrameCount;
                   SpinEdit2.MaxValue := mpFile.FrameCount;
                   SpinEdit1.Value := CurrentFrameIndex + 1;
                   SpinEdit2.Value := CurrentFrameIndex + 1;

                   Label4.Visible := True;
                   Label4.Caption := 'From X';
                   SpinEdit3.MinValue := 0;
                   SpinEdit3.MaxValue := mpFile.FrameWidth - 1;
                   SpinEdit3.Value := 0;
                   SpinEdit3.Visible := True;

                   Label5.Visible := True;
                   Label5.Caption := 'To X';
                   SpinEdit4.MinValue := 0;
                   SpinEdit4.MaxValue := mpFile.FrameWidth - 1;
                   SpinEdit4.Value := mpFile.FrameWidth - 1;
                   SpinEdit4.Visible := True;
               end;

               if opframedlg.ShowModal = mrOK then
               begin
                   fromFrame := opframedlg.SpinEdit1.Value - 1;
                   toFrame := opframedlg.SpinEdit2.Value - 1;
                   chIndex := opframedlg.SelectedCh;
                   fromX := opframedlg.SpinEdit3.Value;
                   toX := opframedlg.SpinEdit4.Value;
                   if (fromFrame <= toFrame) and (fromFrame >= 0) and (fromFrame
                       < mpFile.FrameCount) and (toFrame >= 0) and (toFrame <
                       mpFile.FrameCount) and
                       (fromX >= 0) and (fromX < mpFile.FrameWidth) and
                       (toX >= 0) and (toX < mpFile.FrameWidth) and
                       (toX >= fromX) then
                       begin
                       	destMPFile := TMPFile(opframedlg.ComboBox1.Items.
                               	Objects[opframedlg.ComboBox1.ItemIndex]);
                           if destMPFile.SizeOfFrameCompatible(mpFile.FrameHeight,
                           	toFrame - fromFrame + 1) then
                           begin
                       		oldCursor := Screen.Cursor;
                       		try
                           		Screen.Cursor := crHourGlass;
                       			mpFile.StackY(chIndex, fromFrame, toFrame, fromX, toX,
                                   	destMPFile);
                       		finally
                       			Screen.Cursor := oldCursor;
                       		end;
                           end;
                       end
                   else
                       MessageDlg('Invalid Projection Frames parameters', mtError,
                           [mbOK], 0);
               end;
           end;
end;


procedure TViewerFrm.ProjectFramesonXaxis1Click(Sender: TObject);
var    fromFrame, toFrame, chIndex, fromY, toY: integer;
		oldCursor: TCursor;
       destMPFile: TMPFile;
begin
   if CheckNoFrame then Exit;
       if Mainform.fileList.WorkspaceCount = 0 then
           MessageDlg('No workspace for this operation.' + CRLF +
                       'Create a workspace file first.', mtInformation, [mbOK], 0)
           else
           begin
               with opframedlg do
               begin
                   Caption := 'Project Frames on X axis';
					opframedlg.InitGUI(mpFile);
                   Mainform.fileList.
                       FillComboBoxWithWorkspaces(ComboBox1);
                   ComboBox1.ItemIndex := 0;
                   Label1.Caption := 'From Frame';
                   Label3.Caption := 'To Frame';
                   SpinEdit1.MinValue := 1;
                   SpinEdit2.MinValue := 1;
                   SpinEdit1.MaxValue := mpFile.FrameCount;
                   SpinEdit2.MaxValue := mpFile.FrameCount;
                   SpinEdit1.Value := CurrentFrameIndex + 1;
                   SpinEdit2.Value := CurrentFrameIndex + 1;

                   Label4.Visible := True;
                   Label4.Caption := 'From Y';
                   SpinEdit3.MinValue := 0;
                   SpinEdit3.MaxValue := mpFile.FrameHeight - 1;
                   SpinEdit3.Value := 0;
                   SpinEdit3.Visible := True;

                   Label5.Visible := True;
                   Label5.Caption := 'To Y';
                   SpinEdit4.MinValue := 0;
                   SpinEdit4.MaxValue := mpFile.FrameHeight - 1;
                   SpinEdit4.Value := mpFile.FrameHeight - 1;
                   SpinEdit4.Visible := True;
               end;

               if opframedlg.ShowModal = mrOK then
               begin
                   fromFrame := opframedlg.SpinEdit1.Value - 1;
                   toFrame := opframedlg.SpinEdit2.Value - 1;
					chIndex := opframedlg.SelectedCh;
                   fromY := opframedlg.SpinEdit3.Value;
                   toY := opframedlg.SpinEdit4.Value;
                   if (fromFrame <= toFrame) and (fromFrame >= 0) and (fromFrame
                       < mpFile.FrameCount) and (toFrame >= 0) and (toFrame <
                       mpFile.FrameCount) and
                       (fromY >= 0) and (fromY < mpFile.FrameHeight) and
                       (toY >= 0) and (toY < mpFile.FrameHeight) and
                       (toY >= fromY) then
                       begin
                       	destMPFile := TMPFile(opframedlg.ComboBox1.Items.
                               Objects[opframedlg.ComboBox1.ItemIndex]);
                           if destMPFile.SizeOfFrameCompatible(mpFile.FrameWidth,
                           	toFrame - fromFrame + 1) then
                           begin
                       		oldCursor := Screen.Cursor;
								try
                           		Screen.Cursor := crHourGlass;
                       			mpFile.StackX(chIndex, fromFrame, toFrame, fromY, toY,
                           			destMPFile);
                       		finally
                       			Screen.Cursor := oldCursor;
                       		end;
                           end;
                       end
                   else
                       MessageDlg('Invalid Projection Frames parameters', mtError,
                           [mbOK], 0);
               end;
           end;
end;


procedure TViewerFrm.SubtractwithFrame1Click(Sender: TObject);
var    plusFrame, minusFrame, repeatCount, lastFrame, chIndex, i: integer;
		oldCursor: TCursor;
       destMPFile: TMPFile;
begin
   if CheckNoFrame then Exit;
       if Mainform.fileList.WorkspaceCount = 0 then
           MessageDlg('No workspace for this operation.' + CRLF +
                       'Create a workspace file first.', mtInformation, [mbOK], 0)
           else
           begin
               opframedlg.Caption := 'Subtract Frames';
				opframedlg.InitGUI(mpFile);
               Mainform.fileList.FillComboBoxWithWorkspaces(opframedlg.ComboBox1);
               opframedlg.ComboBox1.ItemIndex := 0;
               opframedlg.Label1.Caption := '+ Frame';
               opframedlg.Label3.Caption := '- Frame';
               opframedlg.Label4.Caption := 'Repeat';
               opframedlg.SpinEdit3.Enabled := True;
               opframedlg.SpinEdit3.Value := 1;
               opframedlg.SpinEdit1.MinValue := 1;
               opframedlg.SpinEdit2.MinValue := 1;
               opframedlg.SpinEdit1.MaxValue := mpFile.FrameCount;
               opframedlg.SpinEdit2.MaxValue := mpFile.FrameCount;
               opframedlg.SpinEdit1.Value := CurrentFrameIndex + 1;
               opframedlg.SpinEdit2.Value := CurrentFrameIndex + 1;

               if opframedlg.ShowModal = mrOK then
               begin
                   plusFrame := opframedlg.SpinEdit1.Value - 1;
                   minusFrame := opframedlg.SpinEdit2.Value - 1;
                   repeatCount := opframedlg.SpinEdit3.Value;

					chIndex := opframedlg.SelectedCh;
                   if (plusFrame >= 0) and (plusFrame < mpFile.FrameCount) and
                       (minusFrame >= 0) and (minusFrame < mpFile.FrameCount) then
                   begin
                       if plusFrame >= minusFrame then
                           lastFrame := plusFrame + repeatCount - 1
                       else
                           lastFrame := minusFrame + repeatCount - 1;
                       if lastFrame >= mpFile.FrameCount then
                           MessageDlg('Too many repeats.', mtError, [mbOK], 0) else
                       begin
                           destMPFile := TMPFile(opframedlg.ComboBox1.Items.
                                       	Objects[opframedlg.ComboBox1.ItemIndex]);
							if destMPFile.SizeOfFrameCompatible(mpFile.FrameWidth,
                           	mpFile.FrameHeight) then
                           begin
                       		oldCursor := Screen.Cursor;
                       		try
                           		Screen.Cursor := crHourGlass;
                           		for i := 0 to repeatCount - 1 do
                               		mpFile.SubtractFrame(chIndex,
                                   	plusFrame + i,
                                   	minusFrame + i,
                                   	destMPFile);
                                   destMPFile.OnNewFrames;
                       		finally
                       			Screen.Cursor := oldCursor;
                       		end;
                           end;
                       end;
                   end
                   else
                       MessageDlg('Invalid Subtract Frames parameters', mtError,
                           [mbOK], 0);
               end;
           end;
end;


procedure TViewerFrm.DeleteallROIs1Click(Sender: TObject);
begin
   ROIList.Clear;
   DrawFrame;
end;


procedure TViewerFrm.MakeAVIMovie1Click(Sender: TObject);
var    chIndex, fromFrame, toFrame: integer;
		oldCursor: TCursor;
       aColorScheme: TColorScheme;
begin
   if CheckNoFrame then Exit;

   with AVIOptDlg do
   begin
   	GroupBox2.Enabled := True;
   	RadioButton5.Checked := True;
   	Label2.Visible := True;
   	SpinEdit3.Visible := True;
   	Label4.Visible := True;
		InitGUI(mpFile);
   	SpinEdit1.MinValue := 1;
   	SpinEdit2.MinValue := 1;
   	SpinEdit1.MaxValue := mpFile.FrameCount;
   	SpinEdit2.MaxValue := mpFile.FrameCount;
   	SpinEdit1.Value := 1;
   	SpinEdit2.Value := mpFile.FrameCount;
   	SpinEdit3.Value := Round(mpFile.FrameRate);
   	Caption := 'Create AVI Movie';
	end;

   with SaveDialog1 do
   begin
       DefaultExt := 'AVI';
       Filter := 'Video Files (*.AVI)|*.AVI|All Files (*.*)|*.*';
       Title := 'Create AVI File';
       if Execute then
           if AVIOptDlg.ShowModal = mrOK then
           begin
				chIndex := AVIOptDlg.SelectedCh;
               fromFrame := AVIOptDlg.SpinEdit1.Value - 1;
               toFrame := AVIOptDlg.SpinEdit2.Value - 1;
               if (fromFrame >= 0) and (fromFrame < mpFile.FrameCount) and
                   (toFrame >= 0) and (toFrame < mpFile.FrameCount) and
                   (AVIOptDlg.SpinEdit3.Value > 0) then
               begin
           		oldCursor := Screen.Cursor;
					if AVIOptDlg.RadioButton5.Checked then
       				aColorScheme := CS_GRAYSCALE
					else if AVIOptDlg.RadioButton6.Checked then
       				aColorScheme := CS_FALSECOLORS
					else
       				aColorScheme := CS_CUSTOMLUT;

                   try
                  		Screen.Cursor := crHourGlass;
                  		mpFile.MakeAVIMovie(SaveDialog1.Filename, chIndex,
                   		fromFrame, toFrame, AVIOptDlg.SpinEdit3.Value, aColorScheme, self,
                           OverlayCh1onCh21.Checked);
           		finally
               		Screen.Cursor := oldCursor;
               	end;
               end
               else
                   MessageDlg('Invalid frames', mtError, [mbOK], 0);
           end;
   end;
end;


procedure TViewerFrm.DeleteallObjects1Click(Sender: TObject);
begin
   if mpFile = nil then Exit;
   if ROIList.Count = 0 then Exit;
   ROIList.Clear;
   OnNewFrame;
   HideROIs1.Checked := False;
   PlotROIofObjects1.Enabled := False;
   HideROIs1.Enabled := False;
   DeleteallObjects1.Enabled := False;
end;


procedure TViewerFrm.HideROIs1Click(Sender: TObject);
begin
   if mpFile = nil then Exit;
   if ROIList.Count = 0 then Exit;
   HideROIs1.Checked := not HideROIs1.Checked;
   OnNewFrame;
end;


procedure TViewerFrm.CreateRectangularROI1Click(Sender: TObject);
begin
   if CheckNoFrame then Exit;
   CreateRectangularROI1.Checked := not CreateRectangularROI1.Checked;
   ToolButton7.Down := CreateRectangularROI1.Checked;
   if CreateRectangularROI1.Checked then
   begin
       ToolButton8.Down := False;
       CreateEllipticalROI1.Checked := False;
   end;
end;


procedure TViewerFrm.CreateEllipticalROI1Click(Sender: TObject);
begin
   if CheckNoFrame then Exit;
   CreateEllipticalROI1.Checked := not CreateEllipticalROI1.Checked;
   ToolButton8.Down := CreateEllipticalROI1.Checked;
   if CreateEllipticalROI1.Checked then
   begin
       ToolButton7.Down := False;
       CreateRectangularROI1.Checked := False;
   end;
end;


procedure TViewerFrm.FindObjects1Click(Sender: TObject);
var chIndex, oldROICount, fromFrame, toFrame,
	 threshold, minArea,
    templateFrom, templateTo: integer;
begin
   if CheckNoFrame then Exit;
   with DetectROIDlg do
   begin
   	CheckBox1.Checked := False;
		CheckBox1.Enabled := (mpFile.VideoChCount >= 2);

		SetGUI(mpFile); {sets radiobuttons in form}
       Label2.Caption := 'Threshold (1..' + IntToStr(mpFile.MaxPixelValue) + ')';

       SpinEdit1.MinValue := 1;
       SpinEdit2.MinValue := 1;
       SpinEdit5.MinValue := 1;
       SpinEdit6.MinValue := 1;

       SpinEdit1.MaxValue := mpFile.FrameCount;
       SpinEdit2.MaxValue := mpFile.FrameCount;
       SpinEdit3.MaxValue := mpFile.MaxPixelValue;

       SpinEdit5.MaxValue := mpFile.FrameCount;
       SpinEdit6.MaxValue := mpFile.FrameCount;

       SpinEdit1.Value := 1;
       SpinEdit2.Value := mpFile.FrameCount;
       SpinEdit5.Value := 1;
       SpinEdit6.Value := 10;
   end;

   if DetectROIDlg.ShowModal = mrOK then
   begin
		chIndex := DetectROIDlg.SelectedCh;
       fromFrame := DetectROIDlg.SpinEdit1.Value - 1;
       toFrame := DetectROIDlg.SpinEdit2.Value - 1;
       threshold := DetectROIDlg.SpinEdit3.Value;
       minArea :=  DetectROIDlg.SpinEdit4.Value;
       templateFrom := DetectROIDlg.SpinEdit5.Value;
       templateTo := DetectROIDlg.SpinEdit6.Value;

       if (fromFrame >= 0) and (fromFrame < mpFile.FrameCount)
           and (toFrame >= 0 ) and (toFrame < mpFile.FrameCount)
           and (threshold > 0) and (threshold <= 2047)
           and (minArea > 0) and (minArea < mpFile.FrameWidth * mpFile.FrameHeight)
           and (templateFrom >= 0 ) and (templateFrom < mpFile.FrameCount)
           and (templateTo >= 0 ) and (templateTo < mpFile.FrameCount)
           and (templateFrom <= templateTo ) then
       begin
           oldROICount := ROIList.Count;
           try
               Screen.Cursor := crHourGlass;
               mpFile.DetectROIs(ROIList, chIndex, fromFrame, toFrame, threshold, minArea, templateFrom, templateTo);
               Screen.Cursor := crDefault;
               MessageDlg(IntToStr(ROIList.Count - oldROICount) + ' ROIs found.',
                   mtInformation, [mbOK], 0);
               if ROIList.Count > oldROICount then
               begin
                   HideROIs1.Enabled := True;
                   PlotROIofObjects1.Enabled := True;
                   DeleteallObjects1.Enabled := True;

                   if DetectROIDlg.CheckBox1.Checked then mpFile.CloneROIs(ROIList, oldROICount);

                   OnNewFrame;
               end;
           except
               Screen.Cursor := crDefault;
           end;
       end
       else
           MessageDlg('Invalid parameter(s) to detect ROIs.', mtError, [mbOK], 0);
   end;
end;


procedure TViewerFrm.PlotROIofObjects1Click(Sender: TObject);
begin
   SelectROIPlot(True, 0);
end;


procedure TViewerFrm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var    origin: TPoint;
       sc: TRect;
begin
   if mpFile = nil then Exit;
   if mpFile.FrameCount = 0 then Exit;

   origin := ClientOrigin;
   if CreateRectangularROI1.Checked or CreateLineProfile1.Checked or
   	AreaStats1.Checked or CreateEllipticalROI1.Checked or
       (mouseAction = maMotionCorrection) then
   begin
       if WindowToChannel(X, Y, currentChannel) then
       	if mpFile.VideoChEnabled[currentChannel] then
           begin
           	sc := chRect[currentChannel];
           	OffsetRect(sc, origin.X, origin.Y);
           	ClipCursor(@sc);
            	if CreateRectangularROI1.Checked then
               	mouseAction := maRectangularROI
            	else if CreateEllipticalROI1.Checked then
               	mouseAction :=  maEllipticROI
            	else if CreateLineProfile1.Checked then
               	mouseAction :=  maLineProfile
            	else if AreaStats1.Checked then
            		mouseAction := maStats;

				if (mouseAction = maRectangularROI) or (mouseAction = maLineProfile) or
       		(mouseAction = maStats) or (mouseAction = maEllipticROI)
               or (mouseAction = maMotionCorrection) then
       		begin
           		anchorX := X;
           		anchorY := Y;
           		prevX := X;
           		prevY := Y;
           		with Canvas do
           		begin
               		Pen.Color := clWhite;
               		Pen.Style := psDot;
               		Pen.Mode := pmXor;
               		Pen.Width := 1;
           		end;
           		if mouseAction <> maEllipticROI then
           			Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
                       Point(prevX, AnchorY), Point(AnchorX, AnchorY)])
           		else
               		Canvas.Arc(AnchorX, AnchorY, X, Y, AnchorX, AnchorY, AnchorX, AnchorY);
                   bMotionCorrectionStarted := (mouseAction = maMotionCorrection);
       		end;
   		end;
   end
   else
   begin
       mouseAction := maNormal;
		if not WindowToChannel(X, Y, currentChannel) then currentChannel := -1;
   end;
end;


procedure TViewerFrm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var    xData, yData, pixelValue: integer;
       roiIndex: integer;
begin
   if mpFile = nil then Exit;

	if WindowToChannel(X, Y, currentChannel) then
   begin
   	if mpFile.VideoChEnabled[currentChannel] then
       begin
       	StatusBar1.Panels[1].Text := 'Ch' + IntToStr(currentChannel + 1);
       	xData := WindowToFrameX(currentChannel, X);
       	yData := WindowToFrameY(Y);
       	pixelValue := mpFile.GetPixelValue(CurrentFrameIndex, currentChannel, xData, yData);
       	StatusBar1.Panels[2].Text := 'X: ' + IntToStr(xData);
       	StatusBar1.Panels[3].Text := 'Y: ' + IntToStr(yData);
       	StatusBar1.Panels[4].Text := 'Pixel: ' + IntToStr(pixelValue);
       end
   end
   else
      currentChannel := -1;

   if (mouseAction = maRectangularROI) or (mouseAction = maStats) or
   ((mouseAction = maMotionCorrection) and bMotionCorrectionStarted) then
   begin
       Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
           Point(prevX, AnchorY), Point(AnchorX, AnchorY)]);
       prevX := X; prevY := Y;
       Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
           Point(prevX, AnchorY), Point(AnchorX, AnchorY)]);
   end
   else if mouseAction = maEllipticROI then
   begin
   	Canvas.Arc(AnchorX, AnchorY, prevX, prevY, AnchorX, AnchorY, AnchorX, AnchorY);
       prevX := X; prevY := Y;
   	Canvas.Arc(AnchorX, AnchorY, prevX, prevY, AnchorX, AnchorY, AnchorX, AnchorY);
   end
   else if mouseAction = maLineProfile then
   begin
       Canvas.Polyline([Point(AnchorX, AnchorY), Point(prevX, prevY)]);
       prevX := X; prevY := Y;
       Canvas.Polyline([Point(AnchorX, AnchorY), Point(prevX, prevY)]);
   end
   else if mouseAction = maNormal then
       if currentChannel >= 0 then
       begin
           roiPt.x := WindowToFrameX(currentChannel, X);
           roiPt.y := WindowToFrameY(Y);
           roiIndex := ROIList.ROIOfPt(currentChannel, roiPt);
           if roiIndex > - 1 then
               StatusBar1.Panels[5].Text := 'ROI: ' + IntToStr(roiIndex + 1)
           else
               StatusBar1.Panels[5].Text := 'ROI:';
       end;
end;


const
	sCreateOtherChROI = 'Do you want to create the same ROI in the other channels?';


procedure TViewerFrm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var    rc: TRect;
       otherChannel: integer;
begin
	bMotionCorrectionStarted := False;
   if mouseAction = maRectangularROI then
   begin
       mouseAction := maNormal;
       CreateRectangularROI1Click(nil); {reset to normal mode}
       ClipCursor(nil);
       rc.Left := WindowToFrameX(currentChannel, anchorX);
       rc.Right := WindowToFrameX(currentChannel, X);
       rc.Top := WindowToFrameY(anchorY);
       rc.Bottom := WindowToFrameY(Y);

       ROIList.AddRectangularROI(currentChannel, rc);
       SelectROIPlot(False, ROIList.Count - 1);

       if mpFile.VideoChCount >= 2 then
       	if MessageDlg(sCreateOtherChROI, mtInformation, [mbOK, mbCancel], 0) = mrOK then
           	for otherChannel := 0 to MAX_CH - 1 do
               	if mpFile.VideoChEnabled[otherChannel] and (otherChannel <> currentChannel) then
           		begin
       				ROIList.AddRectangularROI(otherChannel, rc);
       				SelectROIPlot(False, ROIList.Count - 1);
           		end;

       OnNewFrame;
       HideROIs1.Enabled := True;
       PlotROIofObjects1.Enabled := True;
       DeleteallObjects1.Enabled := True;
   end
   else if mouseAction = maEllipticROI then
   begin
       mouseAction := maNormal;
       CreateEllipticalROI1Click(nil); {reset to normal mode}
       ClipCursor(nil);
       rc.Left := WindowToFrameX(currentChannel, anchorX);
       rc.Right := WindowToFrameX(currentChannel, X);
       rc.Top := WindowToFrameY(anchorY);
       rc.Bottom := WindowToFrameY(Y);

       ROIList.AddEllipticalROI(currentChannel, rc);
       SelectROIPlot(False, ROIList.Count - 1);

       if mpFile.VideoChCount >= 2 then
       	if MessageDlg(sCreateOtherChROI, mtInformation, [mbOK, mbCancel], 0) = mrOK then
           	for otherChannel := 0 to MAX_CH - 1 do
               	if mpFile.VideoChEnabled[otherChannel] and (otherChannel <> currentChannel) then
           		begin
       				ROIList.AddEllipticalROI(otherChannel, rc);
       				SelectROIPlot(False, ROIList.Count - 1);
           		end;

       OnNewFrame;
       HideROIs1.Enabled := True;
       PlotROIofObjects1.Enabled := True;
       DeleteallObjects1.Enabled := True;
   end
   else if mouseAction = maLineProfile then
   begin
       mouseAction := maNormal;
       ClipCursor(nil);
       Canvas.Polyline([Point(AnchorX, AnchorY), Point(prevX, prevY)]);
       rc.Left := WindowToFrameX(currentChannel, anchorX);
       rc.Right := WindowToFrameX(currentChannel, X);
       rc.Top := WindowToFrameY(anchorY);
       rc.Bottom := WindowToFrameY(Y);
       PlotLineProfile(currentChannel, rc);
       CreateLineProfile1Click(nil); {reset to normal mode}
   end
   else if mouseAction = maStats then
   begin
   	AreaStats1Click(nil);
       mouseAction := maNormal;
       ClipCursor(nil);
		{erase rectangle}
       Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
           Point(prevX, AnchorY), Point(AnchorX, AnchorY)]);
       rc.Left := WindowToFrameX(currentChannel, anchorX);
       rc.Right := WindowToFrameX(currentChannel, X);
       rc.Top := WindowToFrameY(anchorY);
       rc.Bottom := WindowToFrameY(Y);
       StatDlg.Initialize(mpFile, CurrentFrameIndex, currentChannel, rc);
       StatDlg.ShowModal;
   end
   else if mouseAction = maMotionCorrection then
   begin
       mouseAction := maNormal;
       ClipCursor(nil);
       rc.Left := WindowToFrameX(currentChannel, anchorX);
       rc.Right := WindowToFrameX(currentChannel, X);
       rc.Top := WindowToFrameY(anchorY);
       rc.Bottom := WindowToFrameY(Y);
       NormalizeRect(rc);
       if (rc.Right - rc.Left < 15) or (rc.Bottom - rc.Top < 15) then
       begin
       	MessageDlg('Motion correction region must be larger than 16 x 16 pixels', mtError, [mbOK], 0);
           {erase rectangle}
           Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
           	Point(prevX, AnchorY), Point(AnchorX, AnchorY)]);
       end
       else
       begin
       	if MessageDlg('Is motion correction region OK?', mtInformation, [mbYes, mbNo], 0) = mrYes then
       	begin
				{erase rectangle}
       		Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
           		Point(prevX, AnchorY), Point(AnchorX, AnchorY)]);
       		MotionCorrectionDlg.Initialize(self, currentFrameIndex, currentChannel, rc);
           	MotionCorrectionDlg.ShowModal;
       	end
       	else
				{erase rectangle}
       		Canvas.Polyline([Point(AnchorX, AnchorY), Point(AnchorX, prevY), Point(prevX, prevY),
           		Point(prevX, AnchorY), Point(AnchorX, AnchorY)]);
       end;
   end
   else if mouseAction = maNormal then
       if currentChannel >= 0 then
       begin
           roiPt.x := WindowToFrameX(currentChannel, X);
           roiPt.y := WindowToFrameY(Y);
       end;
end;


procedure TViewerFrm.FormDblClick(Sender: TObject);
var roiIndex: integer;
begin
   if (mouseAction = maNormal) and (currentChannel >= 0) then
   begin
       roiIndex := ROIList.ROIOfPt(currentChannel, roiPt);
       if roiIndex > - 1 then
           SelectROIPlot(False, roiIndex);
   end;
end;

procedure TViewerFrm.CreateLineProfile1Click(Sender: TObject);
begin
   CreateLineProfile1.Checked := not CreateLineProfile1.Checked;
   ToolButton9.Down := CreateLineProfile1.Checked;
end;


procedure TViewerFrm.CopyFrames1Click(Sender: TObject);
var    fromFrame, toFrame, chIndex: integer;
       s: string;
begin
   if CheckNoFrame then Exit;

   with MTransferDlg do
   begin
		InitGUI(mpFile);
       SpinEdit1.MinValue := 1;
       SpinEdit2.MinValue := 1;
       SpinEdit1.MaxValue := mpFile.FrameCount;
       SpinEdit2.MaxValue := mpFile.FrameCount;
       SpinEdit1.Value := CurrentFrameIndex + 1;
       SpinEdit2.Value := CurrentFrameIndex + 1;
       ListBox1.ItemIndex := 0;
       if MTransferDlg.ShowModal = mrOK then
       begin
           fromFrame := SpinEdit1.Value - 1;
           toFrame := SpinEdit2.Value - 1;
           if ListBox1.ItemIndex = 0 then s := 'base' else s := 'workspace';
			chIndex := SelectedCh;
           if (fromFrame >= 0) and (fromFrame < mpFile.FrameCount) and
               (toFrame >= 0) and (toFrame < mpFile.FrameCount) and
               (SpinEdit3.Value > 0) and (fromFrame <= toFrame) then
               ExportToMatlab(chIndex, fromFrame, toFrame, Edit1.Text, SpinEdit3.Value,
               s)
           else
               MessageDlg('Invalid parameters.', mtError, [mbOK], 0);
       end;
   end;
end;

procedure TViewerFrm.AutomaticBackgroundCorrection1Click(Sender: TObject);
begin
	if CheckNoFrame then Exit;
	AutomaticBackgroundCorrection1.Checked := not AutomaticBackgroundCorrection1.Checked;
   mpFile.DoBackgroundCorrection;
   DrawFrame;
end;

procedure TViewerFrm.AreaStats1Click(Sender: TObject);
begin
	if mouseAction = maNormal then
		AreaStats1.Checked := True
   else if mouseAction = maStats then
		AreaStats1.Checked := False;
end;


procedure TViewerFrm.ExportFramesasamultipageTIFFfile1Click(
  Sender: TObject);
var    chIndex, fromFrame, toFrame: integer;
		oldCursor: TCursor;
       bNoNegativeValues: boolean;
begin
   if CheckNoFrame then Exit;

   with AVIOptDlg do
   begin
		InitGUI(mpFile);
   	SpinEdit1.MinValue := 1;
   	SpinEdit2.MinValue := 1;
   	SpinEdit1.MaxValue := mpFile.FrameCount;
   	SpinEdit2.MaxValue := mpFile.FrameCount;
   	SpinEdit1.Value := 1;
   	SpinEdit2.Value := mpFile.FrameCount;
   	Caption := 'Export as TIFF file';
       RadioButton5.Checked := True;
   	GroupBox2.Enabled := False;
   	Label2.Visible := False;
   	SpinEdit3.Visible := False;
   	Label4.Visible := False;
   end;

   with SaveDialog1 do
   begin
       DefaultExt := 'TIF';
       Filter := 'TIFF Files (*.TIF)|*.TIF|All Files (*.*)|*.*';
       Title := 'Export as TIFF file';
       if Execute then
           if AVIOptDlg.ShowModal = mrOK then
           begin
				chIndex := AVIOptDlg.SelectedCh;
               fromFrame := AVIOptDlg.SpinEdit1.Value - 1;
               toFrame := AVIOptDlg.SpinEdit2.Value - 1;
               if (fromFrame >= 0) and (fromFrame < mpFile.FrameCount) and
                   (toFrame >= 0) and (toFrame < mpFile.FrameCount)
                   and (fromFrame <= toFrame) then
               begin
           		oldCursor := Screen.Cursor;
                   try
                  		Screen.Cursor := crHourGlass;
                  		bNoNegativeValues := mpFile.MakeTIFF(SaveDialog1.Filename, chIndex,
                   	fromFrame, toFrame);
               		Screen.Cursor := oldCursor;
                       if not bNoNegativeValues then
                       	MessageDlg('Negative pixel values changed to 0.',
                           	mtWarning, [mbOK], 0);
                       MessageDlg('Successfully exported frames in TIFF file.',
                       	mtInformation, [mbOK], 0);
					except
               		Screen.Cursor := oldCursor;
                       MessageDlg('Error in creating TIFF file.',
                       	mtError, [mbOK], 0);
               	end;
               end
               else
                   MessageDlg('Invalid frames', mtError, [mbOK], 0);
           end;
   end;
end;

procedure TViewerFrm.CustomColors1Click(Sender: TObject);
begin
	if CustomColors1.Checked then Exit;
	CustomColors1.Checked := True;
	colorScheme := CS_CUSTOMLUT;
   FalseColors1.Checked := False;
   GrayScale1.Checked := False;
   MakeColorScale;
   DrawFrame;
end;


procedure TViewerFrm.FalseColors1Click(Sender: TObject);
begin
	if FalseColors1.Checked then Exit;
	FalseColors1.Checked := True;
	colorScheme := CS_FALSECOLORS;
   CustomColors1.Checked := False;
   GrayScale1.Checked := False;
   MakeColorScale;
   DrawFrame;
end;

procedure TViewerFrm.CustomColorsLookupTable1Click(Sender: TObject);
begin
	LUTDlg := TLUTDlg.Create(Mainform);
   with LUTDlg, mpFile do
   begin
		viewer := Self;
   	dlgBaseColors := baseColors;
   	dlgnegativeColors := negativeColors;
   	dlgmidRangeColors := midRangeColors;
   	dlgmaxColors := maxColors;
       dlgMaxPixels := maxPixels;
	end;

   if LUTDlg.ShowModal = mrOK then
   begin
   	SetLUTColors;
   	if colorScheme <> CS_CUSTOMLUT then
			CustomColors1Click(nil);
   	LUTDlg.Free;
       Invalidate;
   end
   else
   	LUTDlg.Free;
end;


procedure TViewerFrm.PaintBox1Paint(Sender: TObject);
begin
	MakeColorScale;
end;


procedure TViewerFrm.BinaryFrameOperations1Click(Sender: TObject);
begin
	if not Mainform.bBinaryOp then
   	if Mainform.fileList.WorkspaceCount = 0 then
       	MessageDlg('No workspace to store result frame.', mtError, [mbOK], 0)
       else
   	begin
   		BinOpForm := TBinOpForm.Create(mainform);
       	BinOpForm.Show;
			Mainform.bBinaryOp := True;
   	end;
end;

procedure TViewerFrm.OverlayCh1onCh21Click(Sender: TObject);
begin
	OverlayCh1onCh21.Checked := not OverlayCh1onCh21.Checked;
	DrawFrame;
end;


procedure TViewerFrm.OverlayCh2onCh31Click(Sender: TObject);
begin
	OverlayCh2onCh31.Checked := not OverlayCh2onCh31.Checked;
	DrawFrame;
end;


procedure TViewerFrm.EnableMotionCorrection1Click(Sender: TObject);
begin
   if not mpFile.MotionCorrectionEnabled and not EnableMotionCorrection1.Checked then
   	PerformMotionCorrection1Click(nil)
   else
   begin
		EnableMotionCorrection1.Checked := not EnableMotionCorrection1.Checked;
   	mpFile.MotionCorrectionEnabled := EnableMotionCorrection1.Checked;
   end;
end;


procedure TViewerFrm.PerformMotionCorrection1Click(Sender: TObject);
begin
	MessageDlg('With the mouse draw a rectangle to perform motion correction.', mtInformation, [mbOK], 0);
	mouseAction := maMotionCorrection;
end;

end.
